; -----------------------------------------------------------------------------------------------
; BlitzTiles
; -----------------------------------------------------------------------------------------------
;
; (C) 2009 Christian Hart. All rights reserved.
; Please check the "License.txt" provided with this package for terms and conditions.
;
; -----------------------------------------------------------------------------------------------

AppTitle "BlitzTiles 1.02"


Include "inc/qts.bb"
Include "b3dfile.bb"


; -----------------------------------------------------------------------------------------------
; Set main Engine Variables from BlitzTiles.ini or use default values
; -----------------------------------------------------------------------------------------------

ini$=BT_LoadINI(CurrentDir$()+"blitztiles.ini")

Global BT_Scene$				= BT_GetINI("BlitzTiles"	,"Scene"				,"monkeyisland"		,ini)
Global BT_ScreenWidth%			= BT_GetINI("BlitzTiles"	,"ScreenWidth"			,800				,ini)
Global BT_ScreenHeight%			= BT_GetINI("BlitzTiles"	,"ScreenHeight"			,600				,ini)
Global BT_ScreenDepth%			= BT_GetINI("BlitzTiles"	,"ScreenDepth"			,32					,ini)
Global BT_ScreenMode%			= BT_GetINI("BlitzTiles"	,"ScreenMode"			,2					,ini)
Global BT_GameSpeed%			= BT_GetINI("BlitzTiles"	,"GameSpeed"			,60					,ini)
Global BT_LoadMediaToVRAM%		= BT_GetINI("BlitzTiles"	,"LoadMediaToVRAM"		,1					,ini)
Global BT_CalcNormals%			= BT_GetINI("BlitzTiles"	,"CalcNormals"			,1					,ini)
Global BT_MapsPath$				= BT_GetINI("BlitzTiles"	,"MapsPath"				,"maps\"			,ini)
Global BT_TexturePath$			= BT_GetINI("BlitzTiles"	,"TexturePath"			,"textures\"		,ini)
Global BT_ModelPath$			= BT_GetINI("BlitzTiles"	,"ModelPath"			,"models\"			,ini)
Global BT_FontPath$				= BT_GetINI("BlitzTiles"	,"FontPath"				,"fonts\"			,ini)
Global BT_UseFontName$			= BT_GetINI("BlitzTiles"	,"UseFont"				,"Blitz.fon"		,ini)
Global BT_ShowHelp%				= BT_GetINI("BlitzTiles"	,"ShowHelp"				,0					,ini)
Global BT_ShowInformation%		= BT_GetINI("BlitzTiles"	,"ShowInformation"		,0					,ini)
Global BT_OceanPatchResolution%	= BT_GetINI("BlitzTiles"	,"OceanPatchResolution"	,32					,ini)
Global BT_ShorePatchResolution%	= BT_GetINI("BlitzTiles"	,"ShorePatchResolution"	,32					,ini)
Global BT_GroundPatchResolution%= BT_GetINI("BlitzTiles"	,"GroundPatchResolution",32					,ini)
Global BT_FPSfrequency%			= BT_GetINI("BlitzTiles"	,"FPSfrequency"			,500				,ini)
Global BT_FPSfont$				= BT_GetINI("BlitzTiles"	,"FPSfont"				,"ocr.png"			,ini)
Global BT_ShowFPS%				= BT_GetINI("BlitzTiles"	,"ShowFPS"				,1					,ini)
Global BT_RayCubeScale#			= BT_GetINI("BlitzTiles"	,"RaycubeScale"			,0.1				,ini)
Global BT_RayCubeStep#			= BT_GetINI("BlitzTiles"	,"RaycubeStep"			,50.0				,ini)
Global BT_RayTargetScale#		= BT_GetINI("BlitzTiles"	,"RaytargetScale"		,50.0				,ini)
Global BT_PlacesViewRange#		= BT_GetINI("BlitzTiles"	,"PlacesViewRange"		,0.25				,ini)

Global BT_MinimapSize%			= BT_GetINI("Minimap"		,"MinimapSize"			,200				,ini)
Global BT_MinimapTextureSize%	= BT_GetINI("Minimap"		,"MinimapTextureSize"	,256				,ini)
Global BT_MinimapFOVlength%		= BT_GetINI("Minimap"		,"MinimapFOVlength"		,100				,ini)
Global BT_MinimapOffset%		= BT_GetINI("Minimap"		,"MinimapOffset"		,1					,ini)
Global BT_MinimapPlayerR%		= BT_GetINI("Minimap"		,"MinimapPlayerR"		,255				,ini)
Global BT_MinimapPlayerG%		= BT_GetINI("Minimap"		,"MinimapPlayerG"		,0					,ini)
Global BT_MinimapPlayerB%		= BT_GetINI("Minimap"		,"MinimapPlayerB"		,0					,ini)
Global BT_MinimapFrustumR%		= BT_GetINI("Minimap"		,"MinimapFrustumR"		,0					,ini)
Global BT_MinimapFrustumG%		= BT_GetINI("Minimap"		,"MinimapFrustumG"		,255				,ini)
Global BT_MinimapFrustumB%		= BT_GetINI("Minimap"		,"MinimapFrustumB"		,0					,ini)
Global BT_MinimapFrustumA#		= BT_GetINI("Minimap"		,"MinimapFrustumA"		,0.5				,ini)
Global BT_ShowMinimap%			= BT_GetINI("Minimap"		,"ShowMinimap"			,1					,ini)

Global BT_Hazesegments%			= BT_GetINI("Sky"			,"Hazesegments"			,16					,ini)
Global BT_SkyObjectsMulti#		= BT_GetINI("Sky"			,"SkyObjectsMulti"		,32.0				,ini)
Global BT_BrightnessMulti#		= BT_GetINI("Sky"			,"BrightnessMulti"		,128.0				,ini)
Global BT_MoonTextureSize%		= BT_GetINI("Sky"			,"MoonTextureSize"		,512				,ini)
Global BT_StarSizeMin#			= BT_GetINI("Sky"			,"StarSizeMin"			,0.025				,ini)
Global BT_StarSizeMax#			= BT_GetINI("Sky"			,"StarSizeMax"			,0.050				,ini)
Global BT_FixStarsProportion#	= BT_GetINI("Sky"			,"FixStarsProportion"	,0.95				,ini)
Global BT_StarMinBrightness%	= BT_GetINI("Sky"			,"StarMinBrightness"	,64					,ini)
Global BT_StarMaxBrightness%	= BT_GetINI("Sky"			,"StarMaxBrightness"	,255				,ini)


; -----------------------------------------------------------------------------------------------
; Set scene Variables from scene.ini or use default values
; -----------------------------------------------------------------------------------------------

ini$=BT_LoadINI(CurrentDir$()+BT_MapsPath$+BT_Scene+"\"+BT_Scene+".ini")

Global BT_HeightmapFile$		= BT_GetINI("Scene"	,"Heightmap"					,"monkeyisland.ter"			,ini)
Global BT_ColormapFile$			= BT_GetINI("Scene"	,"Colormap"						,"monkeyisland_colormap.jpg",ini)
Global BT_TexturemapFile$		= BT_GetINI("Scene"	,"Texture"						,"monkeyisland_texture.jpg"	,ini)
Global BT_PreviewFile$			= BT_GetINI("Scene"	,"Preview"						,"monkeyisland_preview.jpg"	,ini)
Global BT_Tiles%				= BT_GetINI("Scene"	,"Tiles"						,8					,ini)
Global BT_TerrainQuality#		= BT_GetINI("Scene"	,"Quality"						,32.0				,ini)
Global BT_IsIsland%				= BT_GetINI("Scene"	,"IsIsland"						,1					,ini)
Global BT_WaterSpeed#			= BT_GetINI("Scene"	,"WaterSpeed"					,8.0				,ini)
Global BT_ShoreSpeed#			= BT_GetINI("Scene"	,"ShoreSpeed"					,4.0				,ini)
Global BT_WaterAlpha#			= BT_GetINI("Scene"	,"WaterAlpha"					,0.5				,ini)
Global BT_WaterLevel#			= BT_GetINI("Scene"	,"WaterLevel"					,0.0				,ini)
Global BT_ShoreMove%			= BT_GetINI("Scene"	,"ShoreMove"					,0					,ini)
Global BT_ShowGround%			= BT_GetINI("Scene"	,"ShowGround"					,1					,ini)
Global BT_ShowOcean%			= BT_GetINI("Scene"	,"ShowOcean"					,1					,ini)
Global BT_ShowSeams%			= BT_GetINI("Scene"	,"ShowSeams"					,0					,ini)
Global BT_ShowMeshTiles%		= BT_GetINI("Scene"	,"ShowMeshTiles"				,1					,ini)
Global BT_ShowPlaces%			= BT_GetINI("Scene"	,"ShowPlaces"					,0					,ini)


; -----------------------------------------------------------------------------------------------
; Lights Variables from scene.ini
; -----------------------------------------------------------------------------------------------
Global BT_NormalsFactor#		= BT_GetINI("Light"	,"NormalsFactor"				,100.0				,ini)
Global BT_SwitchNormals%		= BT_GetINI("Light"	,"SwitchNormals"				,0					,ini)
Global BT_SunLightIntensity#	= BT_GetINI("Light"	,"SunLightIntensity"			,10.0				,ini)
Global BT_MoonLightIntensity#	= BT_GetINI("Light"	,"MoonLightIntensity"			,5.0				,ini)
Global BT_UseVertexColors%		= BT_GetINI("Light"	,"UseVertexColors"				,1					,ini)
Global BT_UseTexture%			= BT_GetINI("Light"	,"UseTexture"					,1					,ini)
Global BT_UseDetailmaps%		= BT_GetINI("Light"	,"UseDetailmaps"				,1					,ini)
Global BT_VertexIntensity#		= BT_GetINI("Light"	,"VertexcolorsIntensity"		,1.0				,ini)
Global BT_ShowLights%			= BT_GetINI("Light"	,"ShowLights"					,1					,ini)
Global BT_SunLightType%			= BT_GetINI("Light"	,"SunLightType"					,1					,ini)
Global BT_MoonLightType%		= BT_GetINI("Light"	,"MoonLightType"				,1					,ini)


; -----------------------------------------------------------------------------------------------
; Texture Variables from scene.ini
; -----------------------------------------------------------------------------------------------
Global BT_DetailTexture1$		= BT_GetINI("Textures"	,"DetailMap1"				,"detail1.dds"		,ini)
Global BT_DetailTexture2$		= BT_GetINI("Textures"	,"DetailMap2"				,"detail2.dds"		,ini)
Global BT_DetailScale1#			= BT_GetINI("Textures"	,"DetailScale1"				,16					,ini)
Global BT_DetailScale2#			= BT_GetINI("Textures"	,"DetailScale2"				,1024				,ini)


; -----------------------------------------------------------------------------------------------
; Sky/Light Variables from scene.ini
; -----------------------------------------------------------------------------------------------
Global BT_Stars%				= BT_GetINI("Sky"		,"Stars"					,1000				,ini)
Global BT_SunInclination#		= BT_GetINI("Sky"		,"SunInclination"			,45.0				,ini)
Global BT_MoonPhase#			= BT_GetINI("Sky"		,"MoonPhase"				,0.0				,ini)
Global BT_MoonInclination#		= BT_GetINI("Sky"		,"MoonInclination"			,60.0				,ini)
Global BT_CloudSpeed#			= BT_GetINI("Sky"		,"CloudSpeed"				,8.0				,ini)
Global BT_CloudScale#			= BT_GetINI("Sky"		,"CloudScale"				,4.0				,ini)
Global BT_SunAngle#				= BT_GetINI("Sky"		,"SunAngle"					,90.0				,ini)
Global BT_MoonAngle#			= BT_GetINI("Sky"		,"MoonAngle"				,90.0				,ini)
Global BT_HazeHeight#			= BT_GetINI("Sky"		,"HazeHeight"				,0.5				,ini)
Global BT_ShowHaze%				= BT_GetINI("Sky"		,"ShowHaze"					,1					,ini)
Global BT_ShowSky%				= BT_GetINI("Sky"		,"ShowSky"					,1					,ini)
Global BT_ShowStarTwinkle%		= BT_GetINI("Sky"		,"ShowStarTwinkle"			,1					,ini)
Global BT_ShowBrightness%		= BT_GetINI("Sky"		,"ShowBrightness"			,1					,ini)


; -----------------------------------------------------------------------------------------------
; Camera Variables from scene.ini
; -----------------------------------------------------------------------------------------------
Global BT_CameraMode%			= BT_GetINI("Camera"	,"CameraMode"				,1					,ini)
Global BT_CameraMinRange#		= BT_GetINI("Camera"	,"CameraMinRange"			,0.5				,ini)
Global BT_CameraMaxRangeMulti#	= BT_GetINI("Camera"	,"CameraMaxRangeMulti"		,1.5				,ini)
Global BT_FogMinRange#			= BT_GetINI("Camera"	,"FogMinRange"				,0.0				,ini)
Global BT_FogMaxRangeMulti#		= BT_GetINI("Camera"	,"FogMaxRangeMulti"			,1.5				,ini)
Global BT_CameraCollisionRadius#= BT_GetINI("Camera"	,"CameraCollisionRadius"	,0.5				,ini)
Global BT_CameraBT_DistanceY#	= BT_GetINI("Camera"	,"CameraBT_DistanceY"		,100				,ini)
Global BT_CameraBT_DistanceZ#	= BT_GetINI("Camera"	,"CameraBT_DistanceZ"		,100				,ini)
Global BT_CameraFOV#			= BT_GetINI("Camera"	,"CameraFOV"				,90.0				,ini)
Global BT_ShowWireframe%		= BT_GetINI("Camera"	,"ShowWireframe"			,0					,ini)
Global BT_ShowFog%				= BT_GetINI("Camera"	,"ShowFog"					,1					,ini)


; -----------------------------------------------------------------------------------------------
; Player Variables from scene.ini
; -----------------------------------------------------------------------------------------------
Global BT_PlayerHeight#			= BT_GetINI("Player"	,"PlayerHeight"				,1.4				,ini)
Global BT_PlayerSpeed#			= BT_GetINI("Player"	,"PlayerSpeed"				,0.25				,ini)
Global BT_PlayerGravity#		= BT_GetINI("Player"	,"Gravity"					,0.981				,ini)
Global BT_PlayerAlign%			= BT_GetINI("Player"	,"AlignPlayer"				,0					,ini)
Global BT_PlayerStartX#			= BT_GetINI("Player"	,"StartpositionX"			,-2429.85			,ini)
Global BT_PlayerStartZ#			= BT_GetINI("Player"	,"StartpositionZ"			,-2600.00			,ini)
Global BT_PlayerStartR#			= BT_GetINI("Player"	,"Rotation"					,70					,ini)


; -----------------------------------------------------------------------------------------------
; Minimap Variables from scene.ini (some BlitzTiles.ini values can be replaced by the scene.ini)
; -----------------------------------------------------------------------------------------------
BT_MinimapPlayerR				= BT_GetINI("Minimap"	,"MinimapPlayerR"			,BT_MinimapPlayerR	,ini)
BT_MinimapPlayerG				= BT_GetINI("Minimap"	,"MinimapPlayerG"			,BT_MinimapPlayerG	,ini)
BT_MinimapPlayerB				= BT_GetINI("Minimap"	,"MinimapPlayerB"			,BT_MinimapPlayerB	,ini)
BT_MinimapFrustumR				= BT_GetINI("Minimap"	,"MinimapFrustumR"			,BT_MinimapFrustumR	,ini)
BT_MinimapFrustumG				= BT_GetINI("Minimap"	,"MinimapFrustumG"			,BT_MinimapFrustumG	,ini)
BT_MinimapFrustumB				= BT_GetINI("Minimap"	,"MinimapFrustumB"			,BT_MinimapFrustumB	,ini)
BT_MinimapFrustumA				= BT_GetINI("Minimap"	,"MinimapFrustumA"			,BT_MinimapFrustumA	,ini)
BT_SkyObjectsMulti				= BT_GetINI("BlitzTiles","SkyObjectsMultiplier"		,BT_SkyObjectsMulti	,ini)
BT_BrightnessMulti				= BT_GetINI("BlitzTiles","BrightnessMultiplier"		,BT_BrightnessMulti	,ini)


; -----------------------------------------------------------------------------------------------
; Scene objects
; -----------------------------------------------------------------------------------------------
Global BT_Camera%,BT_Minimap_Player%,BT_Minimap_Frustum%

; Pivots
Global BT_PlayerCenter%,BT_PlayerPivot%,BT_PlayerHead%
Global BT_SunPivot%,BT_MoonPivot%,BT_Skypivot%
Global BT_SunLightPivot%,BT_MoonLightPivot%
Global BT_PlacesPivot%

; Lights
Global BT_SunLight%,BT_MoonLight%

; Quads
Global BT_Sun1%,BT_Sun2%,BT_Sun3%,BT_SunBright1%,BT_SunBright2%,BT_SunGlow%
Global BT_Moon1%,BT_Moon2%,BT_MoonBright1%,BT_MoonBright2%
Global BT_Minimap

; Patches
Global BT_Ocean%,BT_Shore%,BT_Ground%,BT_Sky%,BT_Stratosphere%

; Custom Meshes
Global BT_Player%,BT_Haze%,BT_Starsphere%


; -----------------------------------------------------------------------------------------------
; Terrain Data
; -----------------------------------------------------------------------------------------------
Global BT_TextureSize%,BT_Scale#,BT_HalfScale#


; -----------------------------------------------------------------------------------------------
; Player Data
; -----------------------------------------------------------------------------------------------
Global BT_SpeedMultiplicator%,BT_Switch%,BT_ViewAngle#
Global BT_CamX#,BT_CamY#,BT_CamZ#
Global BT_PlayerX#,BT_PlayerY#,BT_PlayerZ#
Global BT_NX#,BT_NY#,BT_NZ#
Global BT_Gravity#,BT_Antigravity#,BT_PlayerJumps%,BT_Playeronground%
Global BT_PlayerTurnspeed#,BT_PlayerJumpPause%


; -----------------------------------------------------------------------------------------------
; Engine Data
; -----------------------------------------------------------------------------------------------
Global BT_OldSunAngle#=-1,BT_ManualUpdate%,BT_DeltaTimeOld%
Global BT_FramePeriod%=1000/BT_GameSpeed
Global BT_FrameTime%=MilliSecs()-BT_FramePeriod
Global FPS%,FPS_Timer%,FPS_TimerValue%
Global BT_CurrentSpeed#,BT_SpeedTimer%,BT_OldX#,BT_OldY#,BT_OldZ#,BT_NewX#,BT_NewY#,BT_NewZ#
Global BT_ShoreMove1#,BT_ShoreMove2#,BT_WaveMove1#,BT_WaveMove2#,BT_CloudMove#
Global InitStart%=MilliSecs()
Global BT_SaveScreenshot%


; -----------------------------------------------------------------------------------------------
; Media globals
; -----------------------------------------------------------------------------------------------
Global BT_Texture_MoonSphere,BT_Texture_MoonQuad1,BT_Texture_MoonQuad2
Global BT_Texture_Detailmap1%,BT_Texture_Detailmap2%
Global BT_Texture_Water1%,BT_Texture_Water2%
Global BT_Texture_Clouds1%,BT_Texture_Clouds2%,BT_Texture_Clouds3%
Global BT_Texture_Sun1%,BT_Texture_Sun2%,BT_Texture_Sunglow1%,BT_Texture_Sunglow2%
Global BT_Texture_Moonglow%,BT_Texture_SingleStar%
Global BT_Texture_HazeGradient%,BT_Texture_HorizonMask%
Global BT_DomeBulge%,BT_ColorMap%,BT_Numbers%
Global BT_Preview%


; -----------------------------------------------------------------------------------------------
; Arrays
; -----------------------------------------------------------------------------------------------
Dim BT_TileTexture%(BT_Tiles,BT_Tiles),BT_MeshTile%(BT_Tiles,BT_Tiles),BT_VertexBuffer(33,33)
Dim BT_GradientPercent#(0),BT_GradientRed%(0),BT_GradientGreen%(0),BT_GradientBlue%(0)


; -----------------------------------------------------------------------------------------------
; Blitzarrays (Gradients)
; -----------------------------------------------------------------------------------------------
Const BT_ColorSteps%=3600
Global AmbientR%[BT_ColorSteps],AmbientG%[BT_ColorSteps],AmbientB%[BT_ColorSteps]
Global CLScolorR%[BT_ColorSteps],CLScolorG%[BT_ColorSteps],CLScolorB%[BT_ColorSteps]
Global HazeColR%[BT_ColorSteps],HazeColG%[BT_ColorSteps],HazeColB%[BT_ColorSteps]
Global LightR%[BT_ColorSteps],LightG%[BT_ColorSteps],LightB%[BT_ColorSteps]
Global SunLightR%[BT_ColorSteps],SunLightG%[BT_ColorSteps],SunLightB%[BT_ColorSteps]
Global OceanR%[BT_ColorSteps],OceanG%[BT_ColorSteps],OceanB%[BT_ColorSteps]
Global BrightnessR%[BT_ColorSteps],BrightnessG%[BT_ColorSteps],BrightnessB%[BT_ColorSteps]
Global SunAspectX%[BT_ColorSteps],SunAspectY%[BT_ColorSteps],SunAspectZ%[BT_ColorSteps]
Global Sunsizes%[BT_ColorSteps]
Global StarAlpha%[BT_ColorSteps]
Global MoonAlpha%[BT_ColorSteps]
Global SunLightRange%[BT_ColorSteps]
Global MoonLightRange%[BT_ColorSteps]
Global RedBarR%[BT_ColorSteps],RedBarG%[BT_ColorSteps],RedBarB%[BT_ColorSteps]
Global GreenBarR%[BT_ColorSteps],GreenBarG%[BT_ColorSteps],GreenBarB%[BT_ColorSteps]


; -----------------------------------------------------------------------------------------------
; Types
; -----------------------------------------------------------------------------------------------

Type startwinkle
	
	Field id%
	Field brightness%
	Field sourcecolor%
	Field frequency#
	
End Type

Type objFPS
	Field Array[129]
	Field Total
	Field Index
	Field LastTime
	Field LastIndex
End Type

Type Place
	
	Field entity%
	Field raycube%
	Field x#,y#,z#
	Field output$
	Field moving%
	Field visible%
	Field inview%
	
End Type


; -----------------------------------------------------------------------------------------------
; Init 3D Graphics mode
; -----------------------------------------------------------------------------------------------
Graphics3D BT_ScreenWidth,BT_ScreenHeight,BT_ScreenDepth,BT_ScreenMode

CreateDir("B3D")
CreateDir("B3D/"+BT_Scene)

BT_InitGame()

Global c_surfs%=64

Dim c_surf(c_surfs)
Dim c_brush(c_surfs)
Dim c_tex(c_surfs)
Dim c_lm(c_surfs)
Dim c_tex_name$(c_surfs)
Dim c_lm_name$(c_surfs)
Dim c_lm_index%(c_surfs)

; -----------------------------------------------------------------------------------------------
; Main Loop
; -----------------------------------------------------------------------------------------------
While Not KeyHit(1)
	
	Local BT_FrameElapsed%,BT_FrameTicks%,BT_FrameTween#,t%
	
	Repeat BT_FrameElapsed=MilliSecs()-BT_FrameTime Until BT_FrameElapsed
	BT_FrameTicks=BT_FrameElapsed/BT_FramePeriod
	BT_FrameTween=Float(BT_FrameElapsed Mod BT_FramePeriod)/Float(BT_FramePeriod)
	
	For t=1 To BT_FrameTicks
		
		; Update World
		BT_UpdateGame()
		
		BT_FrameTime=BT_FrameTime+BT_FramePeriod
		If t=BT_FrameTicks Then CaptureWorld
		
		; Update Cam
		If BT_CameraMode=1 Then
			If BT_Switch Then
				BT_BeamPlayerTo(BT_CamX,BT_CamZ)
				BT_Switch=False
				RotateEntity BT_Player,0,EntityYaw(BT_Camera),0
			EndIf
			BT_ThirdCam()
		Else
			BT_FreeCam()
		EndIf
		
		UpdateWorld
		
		; Update Pivots
		BT_UpdatePositions()
		
	Next
	
	; tweened render
	RenderWorld BT_FrameTween
	
	; Infotext
	If BT_ShowInformation Then BT_UpdateInfos()
	If BT_ShowHelp Then BT_DrawHelp()
	
	; Draw FPS digits
	BT_UpdateFPS()
	
	; draw places
	If BT_ShowPlaces Then
		ShowEntity BT_PlacesPivot
		BT_UpdateRayCubes()
		BT_CheckRayCollisions()
		BT_UpdatePlaces()
	Else
		HideEntity BT_PlacesPivot
	EndIf
	
	; Save Screenshot
	If BT_SaveScreenshot=True Then SaveBuffer (BackBuffer(),Replace(BT_Scene+"_"+CurrentDate()+" "+CurrentTime()+".bmp",":",""))
	
	Flip 0
	
	; get current FPS value
	FPS=BT_GetFPS()
	
	; get current player / camera speed
	BT_CalcSpeed()
	
Wend

End

Function StripPath$(file$) 
	
	If Len(file$)>0 
		
		For i=Len(file$) To 1 Step -1 
			
			mi$=Mid$(file$,i,1) 
			If mi$="\" Or mi$="/" Then Return name$ Else name$=mi$+name$ 
			
		Next 
		
	EndIf 
	
	Return name$ 
	
End Function 

Function WriteBB3D( f_name$,tiles%,scaler#=1.0 )
	
	file=WriteFile( f_name$ )
	
	b3dSetFile( file )
	
	b3dBeginChunk( "BB3D" )
	b3dWriteInt( 1 )	;version
	
	b3dBeginChunk( "TEXS" ) ; list all textures used by the mesh
	For x=0 To tiles-1
		
		For y=0 To tiles-1
		
			b3dWriteString( "X"+x+"Y"+y+".bmp" ) 	;texture file
			b3dWriteInt( 16+32 )					;flags
			b3dWriteInt( 2 )					;blend
			b3dWriteFloat( 0 )					;x in tex 0 (hu?)
			b3dWriteFloat( 0 )					;y in tex 0
			b3dWriteFloat( 1 )					;x scale 1
			b3dWriteFloat( 1 )					;y scale 1
			b3dWriteFloat( 0 )					;rotation 0
		
		Next
	
	Next
	b3dEndChunk()	;end of TEXS chunk
	
	For x=0 To tiles-1
		
		For y=0 To tiles-1
			
			b3dBeginChunk( "BRUS" )
			b3dWriteInt( 1 )					;1 texture per brush
			b3dWriteString( "X"+x+"Y"+y )		;name
			b3dWriteFloat( 0.5 )					;red
			b3dWriteFloat( 0.5 )					;green
			b3dWriteFloat( 0.5 )					;blue
			b3dWriteFloat( 1 )					;alpha
			b3dWriteFloat( 0.0 )					;shininess
			b3dWriteInt( 1 )					;blend
			b3dWriteInt( 2 )					;FX
			b3dWriteInt( i )					;brush index
			i=i+1
			b3dEndChunk()	;end of BRUS chunk
			
		Next
		
	Next
	
	i=0
	
	For x=0 To tiles-1
		
		For y=0 To tiles-1
	
			b3dBeginChunk( "NODE" )
			b3dWriteString( "X"+x+"Y"+y )
			b3dWriteFloat( 0 )	;x_pos
			b3dWriteFloat( 0 )	;y_pos
			b3dWriteFloat( 0 )	;y_pos
			b3dWriteFloat( 1 )	;x_scale
			b3dWriteFloat( 1 )	;y_scale
			b3dWriteFloat( 1 )	;z_scale
			b3dWriteFloat( 1 )	;rot_w
			b3dWriteFloat( 0 )	;rot_x
			b3dWriteFloat( 0 )	;rot_y
			b3dWriteFloat( 0 )	;rot_z
			WriteMESH( BT_MeshTile(x,y),i,scaler )
			b3dEndChunk()	;end of NODE chunk
			
			i=i+1
			
		Next
		
	Next
	
	b3dEndChunk()	;end of BB3D chunk
	
	CloseFile file
	
End Function

Function WriteMESH( mesh,index,scaler#=1.0 )
	
	n_surfs=CountSurfaces( mesh )
	
	;UpdateNormals mesh
	
	b3dBeginChunk( "MESH" )
	b3dWriteInt( -1 )				;no 'entity' brush
	
	b3dBeginChunk( "VRTS" )
	b3dWriteInt( 3 )			;flags - 0=no normal/color
	b3dWriteInt( 1 )			;0 tex_coord sets
	b3dWriteInt( 2 )			;0 coords per set
	
	For k=1 To n_surfs
		surf=GetSurface( mesh,k )
		n_verts=CountVertices( surf )-1
		
		For j=0 To n_verts
			b3dWriteFloat( VertexX( surf,j ) )			; vertex X coordinate
			b3dWriteFloat( VertexY( surf,j )*scaler )			; vertex Y coordinate
			b3dWriteFloat( VertexZ( surf,j ) )			; vertex Z coordinate
			b3dWriteFloat( VertexNX( surf,j ) )			; vertex normal X
			b3dWriteFloat( VertexNY( surf,j ) )			; vertex normal Y
			b3dWriteFloat( VertexNZ( surf,j ) )			; vertex normal Z
			b3dWriteFloat( VertexRed(surf,j)/255.0 )	; vertex red
			b3dWriteFloat( VertexGreen(surf,j)/255.0 )	; vertex green
			b3dWriteFloat( VertexBlue(surf,j)/255.0 )	; vertex blue
			b3dWriteFloat( VertexAlpha(surf,j)/255.0 )	; vertex alpha
			b3dWriteFloat( VertexU#( surf,j,0 ) ) 		; texture u
			b3dWriteFloat( VertexV#( surf,j,0 ) ) 		; texture v
			;b3dWriteFloat( VertexW#( surf,j,0 ) ) 		; texture w
		Next
	Next
	b3dEndChunk()	;end of VRTS chunk
	
	first_vert=0
	For k=1 To n_surfs
		surf=GetSurface( mesh,k )
		n_tris=CountTriangles( surf )-1
		
		b3dBeginChunk( "TRIS" )
		b3dWriteInt( index )		;brush for these triangles
		
		For j=0 To n_tris
			b3dWriteInt( first_vert+TriangleVertex( surf,j,0 ) )
			b3dWriteInt( first_vert+TriangleVertex( surf,j,1 ) )
			b3dWriteInt( first_vert+TriangleVertex( surf,j,2 ) )
		Next
		
		b3dEndChunk()	;end of TRIS chunk
		
		first_vert=first_vert+CountVertices( surf )
		
	Next
	
	b3dEndChunk()	;end of MESH chunk
	
End Function


; -----------------------------------------------------------------------------------------------
; moves ray cubes to the nearest place targets
; -----------------------------------------------------------------------------------------------
Function BT_UpdateRayCubes()
	
	For i.Place = Each Place
		
		If EntityInView(i\entity,BT_Camera) And BT_Distance(BT_CamX,BT_CamY,BT_CamZ,i\x,i\y,i\z)<(BT_Scale*BT_PlacesViewRange) Then
			
			; set inview flag for later use
			i\inview=True
			
			; ray cube not moving? reset to camera position
			If Not i\moving Then
				PositionEntity i\raycube,BT_CamX,BT_CamY,BT_CamZ
				i\moving=True
			EndIf
			
			; ray cube always points to target cube
			PointEntity i\raycube,i\entity
			
			; distance still greater than target cube radius? move ray cube a step towards the target
			If BT_Distance(EntityX(i\raycube,1),EntityY(i\raycube,1),EntityZ(i\raycube,1),i\x,i\y,i\z)>BT_RayTargetScale Then
				MoveEntity i\raycube,0,0,BT_RayCubeStep
			Else
				i\moving=False
			EndIf
			
		Else
			
			; not visible? flag "not moving" and reset ray cube to cam position
			i\moving=False
			i\inview=False
			
		EndIf
		
	Next
	
End Function


; -----------------------------------------------------------------------------------------------
; checks for ray cube collision events
; -----------------------------------------------------------------------------------------------
Function BT_CheckRayCollisions()
	
	; check if ray cubes collided...
	For i.Place = Each Place
		
		c1=EntityCollided(i\raycube,2)	; ...with terrain
		c2=EntityCollided(i\raycube,4)	; ...with target cube
		
		; collided with terrain = text not visible else text visible
		If c1>0 Then i\moving=False : i\visible=False
		If c2>0 Then i\moving=False : i\visible=True
		
	Next
	
End Function


; -----------------------------------------------------------------------------------------------
; Updates the loader bar width with the current and the milestone progress, including text
; -----------------------------------------------------------------------------------------------
Function BT_UpdateBar(info$,current#,max#,startpercent#=0.0,endpercent#=100.0)
	
	Local percent#,milepercent#
	
	Local width%=BT_ScreenWidth/2
	Local height%=18
	Local midx%=(BT_ScreenWidth/2)
	Local midy%=(BT_ScreenHeight/2)
	Local sx%=midx-(width/2)
	Local sy%=midy-(height/2)
	Local factor#=width*1.0/100
	
	; program termination always possible
	If KeyHit(1) Then End
	
	; calc percentages
	percent=(current*100.0)/max
	milepercent=((percent*(endpercent-startpercent))/100.0)+startpercent
	
	; draw preview image centered
	DrawImage BT_Preview,(BT_ScreenWidth-ImageWidth(BT_Preview))/2,(BT_ScreenHeight-ImageHeight(BT_Preview))/2
	
	; upper bar border, red bar background, green progress bar (total)
	BT_DrawBar(sx,sy,width,height,RedBarR,RedBarG,RedBarB)
	BT_DrawBar(sx,sy,Int(milepercent*factor),height,GreenBarR,GreenBarG,GreenBarB)
	Color 0,0,0 : Rect sx,sy,width+1,height,0
	
	; lower bar border, red bar background, green progress bar (current task)
	BT_DrawBar(sx,sy+height+3,width,height,RedBarR,RedBarG,RedBarB)
	BT_DrawBar(sx,sy+height+3,Int(percent*factor),height,GreenBarR,GreenBarG,GreenBarB)
	Color 0,0,0 : Rect sx,sy+height+3,width+1,height,0
	
	; text infos
	BT_ShadowText(midx,midy-18,"Creating "+Upper(BT_Scene)+" Scene",1,255,255,128,0,0,0,1,1)
	BT_ShadowText(midx,midy-1,Int(milepercent)+"%",1,255,255,255,0,0,0,1,1)
	BT_ShadowText(midx,midy+height+2,info,1,255,255,255,0,0,0,1,1)
	
	Flip 0
	
End Function


; -----------------------------------------------------------------------------------------------
; Get additional 3D Information for the current scene
; -----------------------------------------------------------------------------------------------
Function BT_LoadPlaces()
	
	Local filename$,f%
	Local infostring$,startpos1%,startpos2%
	
	If BT_ShowPlaces Then
	
		filename$=CurrentDir$()+BT_MapsPath$+BT_Scene+"\"+BT_Scene+"_places.ini"
		
		; check if file exists
		f=OpenFile(filename)
	
		If f Then
			
			; read until file ends
			While Not Eof(f)
			
				i.Place = New Place
				
				; divide string by = and ,
				infostring=ReadLine(f)
				startpos1=Instr(infostring,"=",1)
				startpos2=Instr(infostring,",",1)
				
				; create the cube target entity
				i\entity=CreateCube(BT_PlacesPivot)
				EntityAlpha i\entity,0.0
				ScaleEntity i\entity,BT_RayTargetScale,BT_RayTargetScale,BT_RayTargetScale
				EntityType i\entity,4
				EntityRadius i\entity,BT_RayTargetScale
				
				; create the output text
				i\output=Mid(infostring,1,startpos1-1)
				
				; calculate the map position height and position the cube target entity
				i\x=Float(Mid(infostring,startpos1+1,(startpos2-startpos1)-1))
				i\z=Float(Mid(infostring,startpos2+1,Len(infostring)-startpos2))
				PositionEntity i\entity,i\x,0,i\z
				i\y=BT_PickBelow(i\entity,10000)+(BT_RayTargetScale/2.0)
				TranslateEntity i\entity,0,i\y+(BT_RayTargetScale/2.0),0
				
				; create the ray cube entity
				i\raycube=CreateCube(BT_PlacesPivot)
				ScaleEntity i\raycube,BT_RayCubeScale,BT_RayCubeScale,BT_RayCubeScale
				EntityAlpha i\raycube,0.0
				PositionEntity i\raycube,BT_CamX,BT_CamY,BT_CamZ
				EntityType i\raycube,3
				EntityRadius i\raycube,BT_RayCubeScale
				
				; set initial flags
				i\moving=False
				i\visible=False
				
			Wend
		
		EndIf
		
		CloseFile f
	
	EndIf
	
End Function


; -----------------------------------------------------------------------------------------------
; Updates Place names according to their positions in 3D Space
; -----------------------------------------------------------------------------------------------
Function BT_UpdatePlaces()
	
	For i.Place = Each Place
		
		If i\inview=True And i\visible=True Then
			
			CameraProject BT_Camera,i\x,i\y,i\z
			BT_ShadowText(ProjectedX(),ProjectedY(),i\output,1,255,255,255,0,0,0,1,1)
				
		EndIf
		
	Next
	
End Function


; -----------------------------------------------------------------------------------------------
; Returns the BT_Distance between two 3D Points
; -----------------------------------------------------------------------------------------------
Function BT_Distance#(x1#,y1#,z1#,x2#,y2#,z2#)
	
	Return Sqr((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)+(z1-z2)*(z1-z2))
	
End Function


; -----------------------------------------------------------------------------------------------
; Calculates the current Camera or Player Speed in km/h
; -----------------------------------------------------------------------------------------------
Function BT_CalcSpeed#()
	
	Local ms%=MilliSecs()
	
	; check each second
	If ms>BT_SpeedTimer+1000 Then
		
		; store current position
		If BT_CameraMode=0 Then
			BT_NewX=BT_CamX
			BT_NewY=BT_CamY
			BT_NewZ=BT_CamZ
		Else
			BT_NewX=BT_PlayerX
			BT_NewY=BT_PlayerY
			BT_NewZ=BT_PlayerZ
		EndIf
		
		; calculate BT_Distance between current and old position
		BT_CurrentSpeed=BT_Distance(BT_OldX,BT_OldY,BT_OldZ,BT_NewX,BT_NewY,BT_NewZ)*3.6
		
		; store old position
		If BT_CameraMode=0 Then
			BT_OldX=BT_CamX
			BT_OldY=BT_CamY
			BT_OldZ=BT_CamZ
		Else
			BT_OldX=BT_PlayerX
			BT_OldY=BT_PlayerY
			BT_OldZ=BT_PlayerZ
		EndIf
		
		; reset timer
		BT_SpeedTimer=ms
		
	EndIf
	
End Function


; -----------------------------------------------------------------------------------------------
; Outputs FPS
; -----------------------------------------------------------------------------------------------
Function BT_UpdateFPS()
	
	Local sx%,sy%
	Local ms%=MilliSecs()
	
	; use FPS Timer
	If ms>FPS_Timer+BT_FPSfrequency Then
		FPS_TimerValue=FPS
		FPS_Timer=ms
	EndIf
	
	; FPS digits output
	If BT_ShowMinimap Then
		
		sx=BT_ScreenWidth+1
		sy=BT_MinimapSize
		
		; draw black rect around the minimap
		Color 0,0,0
		Rect BT_ScreenWidth-BT_MinimapSize,-1,BT_MinimapSize+1,BT_MinimapSize+1,0
		
	Else
		
		sx=BT_ScreenWidth+1
		sy=-1
		
	EndIf
	
	; draw FPS value
	If BT_ShowFPS Then BT_DrawDigits(sx,sy,BT_Numbers,18,FPS_TimerValue,True)
	
End Function

; -----------------------------------------------------------------------------------------------
; Average FPS calculation
; -----------------------------------------------------------------------------------------------
Function BT_GetFPS()
	
	Local This.objFPS, ThisTime#,ms%
	
	This=First objFPS
	
	If This=Null Then 
		This=New objFPS 
		This\Index=0
		This\LastIndex=1
	EndIf
	
	; fix negative Millisecs values
	ms%=MilliSecs()
	If ms<0 Then ms=ms And $7fffffff
	
	This\Index=(This\Index Shr 0 And 127 Shl 0)+1
	This\LastIndex=(This\LastIndex Shr 0 And 127 Shl 0)+1
	This\Array[This\Index]=ms-This\LastTime 
	This\LastTime=ms
	This\Total=This\Total+This\Array[This\Index]-This\Array[This\LastIndex]
	ThisTime#=Float(This\Total)/128.0
	
	If ThisTime = 0 Then
		
		Return(1000)
		
	Else
		
		Return(1000.0 / ThisTime)
		
	EndIf
	
End Function


; -----------------------------------------------------------------------------------------------
; Draws digits
; -----------------------------------------------------------------------------------------------
Function BT_DrawDigits(sx%,sy%,font%,size%,value%,rt%=False)
	
	Local v$=Str(value),i%
	
	; align right if set
	If rt Then sx=sx-(Len(v)*size)
	
	; output number
	For i=0 To Len(v)-1
		
		DrawBlockRect font,sx+(size*i),sy,(Asc(Mid(v,i+1,1))-48)*size,0,size,size
		
	Next
	
End Function


; -----------------------------------------------------------------------------------------------
; Enhanced Loadtexture function
; -----------------------------------------------------------------------------------------------
Function BT_LoadTexture(filename$,flags%,uscale#=1.0,vscale#=1.0,blendmode%=False)
	
	Local tex%=LoadTexture(BT_TexturePath+filename$,flags)
	ScaleTexture tex,uscale,vscale
	If blendmode Then TextureBlend tex,blendmode
	
	Return tex
	
End Function


; -----------------------------------------------------------------------------------------------
; Creates and scales the Quadtree Terrain Tiles
; -----------------------------------------------------------------------------------------------
Function BT_InitTerrain()
	
	Local path$=BT_MapsPath$+BT_Scene+"\"+BT_HeightmapFile
	
	; Creating the terrain
	QTS_CreateTerrain(path,BT_Tiles,BT_TerrainQuality,BT_CalcNormals,BT_NormalsFactor,BT_SwitchNormals,BT_UseVertexColors,BT_VertexIntensity,BT_ColorMap)
	ScaleEntity QTS_Terrain,QTS_XSCALE,1,QTS_XSCALE
	BT_Scale=QTS_XSCALE*QTS_XPTS
	BT_HalfScale#=BT_Scale/2.0
	
End Function


; -----------------------------------------------------------------------------------------------
; Textures the Quadtree Terrain Tiles
; -----------------------------------------------------------------------------------------------
Function BT_TextureTiles()
	
	Local vertex%,u#,v#
	Local x%,z%,mesh%,surf%
	
	cube=CreateCube()
	
	For t.QTS_TPatch = Each QTS_TPatch
		
		; get type data
		x=t\xtab
		z=t\ztab
		mesh=t\mesh
		surf=t\surf
		BT_MeshTile(x,z)=mesh
		
		; show seams red if set
		If BT_ShowSeams Then
			
			For vertex=0 To CountVertices(surf)-1
				u=VertexU(surf,vertex)
				v=VertexV(surf,vertex)
				If u=0 Or u=1 Or v=0 Or v=1 Then VertexColor surf,vertex,255,0,0
			Next
			
		EndIf
		
		; apply textures to tile
		If x<BT_Tiles And z<BT_Tiles Then
			
			If BT_UseTexture Then
				TextureBlend BT_TileTexture(x,z),2
				EntityTexture BT_MeshTile(x,z),BT_TileTexture(x,z),0,0
			EndIf
			
			If BT_UseDetailmaps Then
				EntityTexture BT_MeshTile(x,z),BT_Texture_Detailmap1,0,1
				EntityTexture BT_MeshTile(x,z),BT_Texture_Detailmap2,0,2
			EndIf
			
		EndIf
		
		; apply FX
		EntityFX BT_MeshTile(x,z),2
		
		; make tile collidable
		EntityType BT_MeshTile(x,z),2
		
		; might look better than built-in normal calculation but creates chunk seams
		If BT_CalcNormals=0 Then UpdateNormals BT_MeshTile(x,z)
		
	Next
	
	WriteBB3D("B3D/"+BT_Scene+"/terrain.b3d",BT_Tiles,1.0/QTS_XSCALE)
	
End Function


; -----------------------------------------------------------------------------------------------
; Cuts the Megatexture to smaller chunks
; -----------------------------------------------------------------------------------------------
Function BT_CutColorMap(filename$)
	
	Local x%,y%,z%,rgb%
	Local width%=BT_GetImageSize(filename,0)
	Local texturemap%
	
	; calculate texture tile size
	BT_TextureSize=width/BT_Tiles
	
	; load huge texture as animated image to fit in RAM or VRAM
	texturemap=LoadAnimImage(filename,BT_TextureSize,BT_TextureSize,0,BT_Tiles^2)
	MaskImage texturemap,255,0,255
	
	; create textures
	For y=0 To BT_Tiles-1
		
		BT_UpdateBar("Cutting Texture",y,BT_Tiles-1,70,80)
		
        For x=0 To BT_Tiles-1
			
			BT_TileTexture(x,y)=CreateTexture(BT_TextureSize,BT_TextureSize,16+32)
			
			; use black background
			ClsColor 0,0,0
			Cls
			
			; draw texture part to backbuffer
			DrawImage texturemap,0,0,(y*BT_Tiles)+x
			
			; grab it to the texturebuffer
            CopyRect 0,0,BT_TextureSize,BT_TextureSize,0,0,BackBuffer(),TextureBuffer(BT_TileTexture(x,y))
            
			Cls
			
        Next
        
    Next
	
	; align texture seams
	For y=0 To BT_Tiles-1
		
		BT_UpdateBar("Align Texture Seams",y,BT_Tiles-1,80,90)
		
		For x=0 To BT_Tiles-1
			
			LockBuffer TextureBuffer(BT_TileTexture(x,y))
			
			If x<BT_Tiles-1 Then LockBuffer TextureBuffer(BT_TileTexture(x+1,y))
			If y<BT_Tiles-1 Then LockBuffer TextureBuffer(BT_TileTexture(x,y+1))
			
			For z=0 To BT_TextureSize-1
				
				; horizontal
				If x<BT_Tiles-1 Then
					rgb=ReadPixelFast(0,z,TextureBuffer(BT_TileTexture(x+1,y)))
					WritePixelFast BT_TextureSize-1,z,rgb,TextureBuffer(BT_TileTexture(x,y))
				EndIf
				
				; vertical
				If y<BT_Tiles-1 Then
					rgb=ReadPixelFast(z,0,TextureBuffer(BT_TileTexture(x,y+1)))
					WritePixelFast z,BT_TextureSize-1,rgb,TextureBuffer(BT_TileTexture(x,y))
				EndIf
				
			Next
			
			UnlockBuffer TextureBuffer(BT_TileTexture(x,y))
			
			SaveBuffer TextureBuffer(BT_TileTexture(x,y)),"B3D/"+BT_Scene+"/x"+x+"y"+y+".bmp"
			
			If x<BT_Tiles-1 Then UnlockBuffer TextureBuffer(BT_TileTexture(x+1,y))
			If y<BT_Tiles-1 Then UnlockBuffer TextureBuffer(BT_TileTexture(x,y+1))
			
		Next
	Next
	
	
	
	; release unused megatexture source image
	FreeImage texturemap
	
End Function


; -----------------------------------------------------------------------------------------------
; reads image size without loading the whole image first
; -----------------------------------------------------------------------------------------------
Function BT_GetImageSize(FImage$,FAxis%)
	
	FImage=Lower$(FImage)
	
	Local IFile%
	Local ISize%
	Local IFileX%=-1
	Local IFileY%=-1
	Local ICode%=$C0
	Local ICheck%=0
	Local ICount%
	
	If FileType(FImage)=1 Then
		
		Select Right$(FImage,4)
				
			Case ".bmp"
				
				IFile=ReadFile(FImage)
				SeekFile IFile,18
				IFileX=ReadInt(IFile)
				IFileY=ReadInt(IFile)
				CloseFile IFile
				ICheck=1
				
			Case ".pcx"
				
				IFile=ReadFile(FImage)
				SeekFile IFile,8
				IFileX=ReadShort(IFile)+1
				IFileY=ReadShort(IFile)+1
				CloseFile IFile
				ICheck=1
				
			Case ".tga"
				
				IFile=ReadFile(FImage)
				SeekFile IFile,12
				IFileX=ReadShort(IFile)
				IFileY=ReadShort(IFile)
				CloseFile IFile
				ICheck=1
				
			Case ".png"
				
				IFile=ReadFile(FImage)
				SeekFile IFile,16
				IFileX=(ReadByte(IFile)*$1000000)+(ReadByte(IFile)*$10000)+(ReadByte(IFile)*$100)+(ReadByte(IFile)*$1)
				IFileY=(ReadByte(IFile)*$1000000)+(ReadByte(IFile)*$10000)+(ReadByte(IFile)*$100)+(ReadByte(IFile)*$1)
				CloseFile IFile
				ICheck=1
				
			Case ".jpg"
				
				IFile=ReadFile(FImage)
				ISize=FileSize(FImage)-10
				If ISize>65532 Then ISize=65532
				SeekFile IFile,0
				For ICount=0 To ISize
					If ReadByte(IFile)=$FF Then
						If ReadByte(IFile)=$C2 Then ICode=$C2
					End If
				Next
				SeekFile IFile,0
				
				For ICount=0 To ISize
					
					If ReadByte(IFile)=$FF Then
						
						If ReadByte(IFile)=ICode Then
							
							ReadByte(IFile)
							ReadByte(IFile)
							ReadByte(IFile)
							IFileY=(ReadByte(IFile)*$100)+(ReadByte(IFile)*$1)
							IFileX=(ReadByte(IFile)*$100)+(ReadByte(IFile)*$1)
							
						End If
						
					End If
					
				Next
				
				CloseFile IFile
				ICheck=1
				
		End Select
		
		If ICheck=1 Then
			
			If FAxis=0 Then Return IFileX
			If FAxis=1 Then Return IFileY
			
		End If
		
	End If
	
	Return -1
	
End Function


; -----------------------------------------------------------------------------------------------
; Loads the textures and images
; -----------------------------------------------------------------------------------------------
Function BT_LoadMedia()
	
	Local s#=BT_CloudScale
	Local s1#=1.0/BT_DetailScale1
	Local s2#=1.0/BT_DetailScale2
	
	If BT_LoadMediaToVRAM Then Local vram%=256
	
	; Create Moonphase
	BT_Texture_MoonSphere	= BT_LoadTexture("moon.jpg"			,0+vram)
	BT_Texture_MoonQuad1	= BT_LoadTexture("moon1.png"		,2+vram)
	BT_Texture_MoonQuad2	= BT_LoadTexture("moon2.png"		,2+vram)
	
	; Loading Textures
	BT_Texture_Detailmap1	= BT_LoadTexture(BT_DetailTexture1	,0+8+vram,s1		,s1  	,5)
	BT_Texture_Detailmap2	= BT_LoadTexture(BT_DetailTexture2	,0+8+vram,s2		,s2		,5)
	BT_Texture_Water1		= BT_LoadTexture("mywaves.dds"		,2+8+vram,1.0/16	,1.0/16	,2)
	BT_Texture_Water2		= BT_LoadTexture("mywaves.dds"		,2+8+vram,1.0/32	,1.0/32	,5)
	BT_Texture_Clouds1		= BT_LoadTexture("clouds1.dds"		,2+8+vram,1.0/2		,1.0/2	,2)
	BT_Texture_Clouds2		= BT_LoadTexture("clouds2.dds"		,2+8+vram,1.0/s		,1.0/s	,2)
	BT_Texture_Clouds3		= BT_LoadTexture("iceclouds.dds"	,2+8+vram,1.0/s		,1.0/s	,2)
	BT_Texture_Sun1			= BT_LoadTexture("sun1.dds"			,2+8+vram)
	BT_Texture_Sun2			= BT_LoadTexture("sun2.dds"			,2+8+vram)
	BT_Texture_HorizonMask	= BT_LoadTexture("mask.dds"			,2+8+vram)
	BT_Texture_Sunglow1		= BT_LoadTexture("sunshine1.dds"	,2+8+vram,1			,1		,3)
	BT_Texture_Sunglow2		= BT_LoadTexture("sunshine2.dds"	,2+8+vram,1			,1		,5)
	BT_Texture_Moonglow		= BT_LoadTexture("moonmask.dds"		,2+8+vram,1			,1		,3)
	BT_Texture_SingleStar	= BT_LoadTexture("dot.png"			,2+8+vram)
	BT_Texture_HazeGradient	= BT_LoadTexture("haze.dds"			,2+8+vram)
	
	; Loading Images
	BT_DomeBulge=LoadImage(BT_TexturePath+"dome.png")
	BT_Numbers=LoadImage(BT_FontPath+BT_FPSfont)
	BT_Preview=LoadImage(BT_MapsPath$+BT_Scene+"\"+BT_PreviewFile)
	
End Function


; -----------------------------------------------------------------------------------------------
; Inits the whole scene
; -----------------------------------------------------------------------------------------------
Function BT_InitGame()
	
	; use the nice blitz font instead of the ugly courier-style
	Local font%=LoadFont(BT_FontPath+BT_UseFontName)
	If font Then SetFont font
	
	; Create color gradients
	BT_InitGradients()
	
	; Load all textures and images
	BT_LoadMedia()
	
	; Creates the Quadtree Terrain Tiles
	BT_ColorMap=LoadImage(BT_MapsPath$+BT_Scene+"\"+BT_ColormapFile)
	BT_InitTerrain()
	
	; Cuts the large Megatexture to smaller Texture chunks
	BT_CutColorMap(BT_MapsPath$+BT_Scene+"\"+BT_TexturemapFile)
	
	BT_UpdateBar("Texturing Tiles",50,100,90,93)
	
	; Textures the tiles (without detail texture)
	BT_TextureTiles()
	
	BT_UpdateBar("Initializing Scene",50,100,93,96)
	
	; Init Scene
	BT_InitScene()
	
	; Init Player Position
	BT_InitPlayer(BT_PlayerStartX,BT_PlayerStartZ)
	
	; Loading Places (if available)
	If BT_ShowPlaces Then BT_LoadPlaces()
	
	BT_UpdateBar("Creating Minimap",50,100,96,100)
	
	; Create Minimap and apply the detail texture
	BT_CreateMinimap()
	
	BT_UpdateBar("Finished in "+BT_RoundTo(((MilliSecs()-InitStart)/1000.0),1)+" seconds",100,100,100,100)
	
	; Inits the moon quad
	BT_InitMoon() : Cls
	
	; Collisions
	Collisions 1,2,2,3		; Camera<>Terrain
	Collisions 3,2,2,3		; Rays<>Terrain
	Collisions 3,4,2,3		; Rays<>Targets
	
	; prepare Screen
	MoveMouse BT_ScreenWidth/2,BT_ScreenHeight/2
	SetBuffer BackBuffer()
	
End Function


; -----------------------------------------------------------------------------------------------
; Draws a bar with a smooth gradient
; -----------------------------------------------------------------------------------------------
Function BT_DrawBar(x%,y%,width%,height%,R[BT_ColorSteps],G[BT_ColorSteps],B[BT_ColorSteps])
	
	Local i%,c%
	
	For i=0 To height-1
		
		c=(BT_ColorSteps/height)*i
		
		Color R[c],G[c],B[c]
		Line x,y+i,x+width,y+i
		
	Next
	
End Function

; -----------------------------------------------------------------------------------------------
; Creates smooth color gradients
; -----------------------------------------------------------------------------------------------
Function BT_InitGradients()
	
	; Gradients
	Restore BT_Ambientlight		: BT_CreateGradient(9,BT_ColorSteps,False,AmbientR,AmbientG,AmbientB)
	Restore BT_ClsColor			: BT_CreateGradient(9,BT_ColorSteps,False,CLScolorR,CLScolorG,CLScolorB)
	Restore BT_HazeColor		: BT_CreateGradient(9,BT_ColorSteps,False,HazeColR,HazeColG,HazeColB)
	Restore BT_LightColor		: BT_CreateGradient(9,BT_ColorSteps,False,LightR,LightG,LightB)
	Restore BT_SunLightColor	: BT_CreateGradient(9,BT_ColorSteps,False,SunLightR,SunLightG,SunLightB)
	Restore BT_OceanColor		: BT_CreateGradient(7,BT_ColorSteps,False,OceanR,OceanG,OceanB)
	Restore BT_Sunsize			: BT_CreateGradient(9,BT_ColorSteps,False,Sunsizes,Sunsizes,Sunsizes)
	Restore BT_StarLight		: BT_CreateGradient(7,BT_ColorSteps,False,StarAlpha,StarAlpha,StarAlpha)
	Restore BT_Brightness		: BT_CreateGradient(7,BT_ColorSteps,False,BrightnessR,BrightnessG,BrightnessB)
	Restore BT_MoonAlpha		: BT_CreateGradient(9,BT_ColorSteps,False,MoonAlpha,MoonAlpha,MoonAlpha)
	Restore BT_SunAspect		: BT_CreateGradient(9,BT_ColorSteps,False,SunAspectX,SunAspectY,SunAspectZ)
	Restore BT_SunLightRange	: BT_CreateGradient(9,BT_ColorSteps,False,SunLightRange,SunLightRange,SunLightRange)
	Restore BT_MoonLightRange	: BT_CreateGradient(9,BT_ColorSteps,False,MoonLightRange,MoonLightRange,MoonLightRange)
	
	; Bars
	Restore BT_Redbar			: BT_CreateGradient(2,BT_ColorSteps,False,RedBarR,RedBarG,RedBarB)
	Restore BT_Greenbar			: BT_CreateGradient(2,BT_ColorSteps,False,GreenBarR,GreenBarG,GreenBarB)
	
End Function


; -----------------------------------------------------------------------------------------------
; Outputs runtime Text info
; -----------------------------------------------------------------------------------------------
Function BT_UpdateInfos()
	
	Local mode$,media$,visible%,x%,y%,i%,px#,py#,pz#
	Local infos$[20]
	Local percent#
	
	If BT_CameraMode=1 Then
		mode="3rd Person"
		px=BT_PlayerX
		py=BT_PlayerY
		pz=BT_PlayerZ
	Else
		mode="Free Flight"
		px=BT_CamX
		py=BT_CamY
		pz=BT_CamZ
	EndIf
	
	If BT_LoadMediaToVRAM Then media="Video RAM" Else media="System RAM"
	
	; calculate visible mesh tiles
	For y=0 To BT_Tiles-1
		For x=0 To BT_Tiles-1
			If EntityInView(BT_MeshTile(x,y),BT_Camera) Then visible=visible+1
		Next
	Next
	
	; calculate day percent
	percent=BT_Normalize(BT_SunAngle,0,360,0,100)
	
	infos[0]="Triangles rendered...: "+TrisRendered()
	infos[1]="Frames per Second....: "+FPS
	infos[2]="Day Time = Angle = %.: "+BT_CalculateTime()+" = "+BT_RoundTo(BT_SunAngle,2)+" = "+BT_RoundTo(percent,2)+"%"
	infos[3]="Total Tiles [Matrix].: "+Int(BT_Tiles^2)+" ["+BT_Tiles+"x"+BT_Tiles+"]"
	infos[4]="Visible Tiles........: "+visible+"/"+Int(BT_Tiles^2)
	infos[5]="Texture size per Tile: "+BT_TextureSize+"x"+BT_TextureSize
	infos[6]="World Detail Quality.: "+BT_TerrainQuality
	infos[7]="Horizontal Range.....: "+Int(BT_Scale)+"m ["+Int((BT_Scale/1000.0)^2)+"km]"
	infos[8]="Viewing Distance.....: "+BT_CameraMinRange+"m to "+(BT_CameraMaxRangeMulti*BT_Scale)+"m"
	infos[9]="Vertical Range.......: "+QTS_MinHeight+"m to "+QTS_MaxHeight+"m"
	infos[10]="Current Position XYZ.: "+BT_RoundTo(px,2)+","+BT_RoundTo(py,2)+","+BT_RoundTo(pz,2)
	infos[11]="Current Speed........: "+BT_RoundTo(BT_CurrentSpeed,1)+" km/h"
	infos[12]="Camera Mode..........: "+mode
	infos[13]="Camera FOV/View angle: "+Int(BT_CameraFOV)+" / "+BT_RoundTo(EntityYaw(BT_Camera)*-1,2)+""
	infos[14]="Media Location.......: "+media
	infos[15]="SIZE.................: "+QTS_Size
	infos[16]="XPTS.................: "+QTS_XPTS
	infos[17]="XSCALE...............: "+QTS_XSCALE
	infos[18]="YSCALE...............: "+QTS_YSCALE
	infos[19]="HSCALE...............: "+QTS_HSCALE
	infos[20]="HBASE................: "+QTS_HBASE
	
	; shadowed text output (slow)
	For i=0 To 20 : BT_ShadowText(0,(i*15),infos[i],1,255,255,255,0,0,0) : Next
	
End Function


; -----------------------------------------------------------------------------------------------
; Outputs text with a shadow
; -----------------------------------------------------------------------------------------------
Function BT_ShadowText(x%,y%,textstring$,offset%,rt%,gt%,bt%,rs%,gs%,bs%,centerx%=0,centery%=0)
	
	Color rs,gs,bs : Text x+offset,y+offset,textstring,centerx,centery
	Color rt,gt,bt : Text x,y,textstring,centerx,centery
	
End Function


; -----------------------------------------------------------------------------------------------
; Rounds a value (ex. 12.345678 with 2 digits -> 12.34 or 90.0 -> 90.00)
; -----------------------------------------------------------------------------------------------
Function BT_RoundTo$(value#,digits%=2)
	
	Local i%
	Local factor#=10^digits
	Local ints%=Int(Floor(value))
	Local modstring$=Str(Int((value-ints)*factor))
	Local modlength%=Len(modstring)
	
	If modlength<digits Then
		For i=1 To (digits-modlength)
			modstring=modstring+"0"
		Next
	EndIf
	
	Return ints+"."+modstring
	
End Function
	
; -----------------------------------------------------------------------------------------------
; Displays runtime help
; -----------------------------------------------------------------------------------------------
Function BT_DrawHelp()
	
	Local hints$[32],i%
	
	hints[0]="BLITZ TILES HELP"
	hints[1]=""
	hints[2]="KEYBOARD"
	hints[3]="--------------------------------------------------------------------------"
	hints[4]="1-0      predefined sun angles from 90...270 degrees, 0 is midnight"
	hints[5]="Q/W      decrease/increase sun angle"
	hints[6]="ENTER    switch camera mode (in freeflight: player position=cam position!)"
	hints[7]="SPACE    WireFrame on/off"
	hints[8]="RTShift  speedup player 3x (in freeflight: 25x)"
	hints[9]="TAB      MeshTerrain on/off"
	hints[10]="F        Fog on/off"
	hints[11]="A        Player alignment on/off"
	hints[12]="T        Star Twinkle on/off"
	hints[13]="B        Sun Brightness on/off"
	hints[14]="G        show/hide Ground"
	hints[15]="O        show/hide Ocean"
	hints[16]="H        show/hide Haze"
	hints[17]="S        show/hide Sky"
	hints[18]="I        show/hide Infos (hide to boost FPS)
	hints[19]="L        show/hide Light sources"
	hints[20]="M        show/hide Minimap"
	hints[21]="P        show/hide Place Names (if used)"
	hints[22]="Arrows   in 3rd person mode: move forward/backwards And turn Left/Right"
	hints[23]="         in freeflight mode: move forward/backwards And sidewards"
	hints[24]="
	hints[25]="MOUSE"
	hints[26]="--------------------------------------------------------------------------"
	hints[27]="LMB      in 3rd person mode: jump"
	hints[28]="         in freeflight mode: move up"
	hints[29]="RMB      speedup player 3x (in Freeflight mode: 100x)"
	hints[30]="Wheel    Change Camera FOV"
	hints[31]="Move     in 3rd person mode: rotates around the player"
	hints[32]="         in freeflight mode: look around"
	
	; shadowed text output (very slow)
	For i=0 To 32 : BT_ShadowText(0,i*15,hints[i],1,255,255,255,0,0,0) : Next
	
End Function


; -----------------------------------------------------------------------------------------------
; Updates player position on minimap
; -----------------------------------------------------------------------------------------------
Function BT_UpdateMinimap()
	
	Local mx#,my#,cx#,cy#,f1x#,f1y#,f2x#,f2y#
	Local fov#,surf%,px#,py#,pz#
	
	If BT_CameraMode=1 Then
		
		; calculate player position
		mx=BT_PlayerX/BT_Scale*BT_MinimapSize
		my=BT_PlayerZ/BT_Scale*BT_MinimapSize
		
	Else
		
		; calculate camera position
		mx=BT_CamX/BT_Scale*BT_MinimapSize
		my=BT_CamZ/BT_Scale*BT_MinimapSize
		
	EndIf
	
	; limit Player position on minimap
	If mx<-BT_MinimapSize/2.0 Then mx=-BT_MinimapSize/2.0
	If mx>BT_MinimapSize/2.0 Then mx=BT_MinimapSize/2.0
	If my<-BT_MinimapSize/2.0 Then my=-BT_MinimapSize/2.0
	If my>BT_MinimapSize/2.0 Then my=BT_MinimapSize/2.0
	
	; calculate minimap center
	cx=-(BT_ScreenWidth/2)+(BT_MinimapSize/2)+BT_ScreenWidth-BT_MinimapSize
	cy=(BT_ScreenHeight/2)-(BT_MinimapSize/2)
	
	; calculate camera angle
	BT_ViewAngle=EntityYaw(BT_Camera,1)+90
	fov=BT_CameraFOV/2.0
	
	; calculate frustum vertices
	f1x=BT_MinimapFOVlength*Cos(BT_ViewAngle-fov)
	f1y=BT_MinimapFOVlength*Sin(BT_ViewAngle-fov)
	f2x=BT_MinimapFOVlength*Cos(BT_ViewAngle+fov)
	f2y=BT_MinimapFOVlength*Sin(BT_ViewAngle+fov)
	
	; reposition frustum vertices
	surf=GetSurface(BT_Minimap_Frustum,1)
	VertexCoords surf,1,f1x,f1y,0
	VertexCoords surf,2,f2x,f2y,0
	
	; calculate position of player and frustum
	px=cx+mx+BT_MinimapOffset
	py=cy+my+BT_MinimapOffset
	pz=BT_ScreenWidth/2.0*BT_SetFOV(BT_CameraFOV)
	
	; reposition player and frustum
	PositionEntity BT_Minimap_Player,px,py,pz
	PositionEntity BT_Minimap_Frustum,px,py,pz
	
End Function


; -----------------------------------------------------------------------------------------------
; Calculate human readable time from angle time
; -----------------------------------------------------------------------------------------------
Function BT_CalculateTime$()
	
	Local time%=BT_SunAngle*4
	Local hours%=Int(Floor(time/60.0))
	Local minutes%=time-(hours*60)
	
	Return BT_ZERO(hours)+":"+BT_ZERO(minutes)
	
	
End Function


; -----------------------------------------------------------------------------------------------
; Adds BT_ZEROs in front of single digit numbers (ex. 9->09)
; -----------------------------------------------------------------------------------------------
Function BT_ZERO$(number%,lenght%=2)
	
	Local i%,r$
	
	For i=0 To lenght-Len(Str(number))-1 : r$=r$+"0" : Next
	Return r$+Str(number)
	
End Function


; -----------------------------------------------------------------------------------------------
; Creates a haze ring around the world
; -----------------------------------------------------------------------------------------------
Function BT_InitHaze(radius#,h#,segments,fx%=0,r%=255,g%=255,b%=255,a1#=0.0,a2#=1.0)
	
	Local ang1#,ang2#,inc#,x1#,z1#,x2#,z2#
	Local uu1#,uu2#,uv1#,uv2#,uv3#
	Local v0%,v1%,v2%,v3%,v4%,v5%
	
	Local mesh=CreateMesh()
	Local surf=CreateSurface(mesh)
	
	inc=360.0/segments
	
	; complete circle
	While ang1<360
		
		; Angle
		ang2=(ang1+inc) Mod 360
		
		; Vertex coordinates
		x1=radius*Cos(ang1)
		z1=radius*Sin(ang1)
		x2=radius*Cos(ang2)
		z2=radius*Sin(ang2)
		
		; UV-coordinates
		uu1=1.0-(ang1/180.0)
		uu2=1.0-(ang1+inc)/180.0
		uv1=1.00
		uv2=0.50
		uv3=0.00
		
		; Add and color vertices
		v0=AddVertex(surf,x1,-h,z1,uu1,uv1) : VertexColor surf,v0,r,g,b,a1
		v1=AddVertex(surf,x2,-h,z2,uu2,uv1) : VertexColor surf,v1,r,g,b,a1
		v2=AddVertex(surf,x1, 0,z1,uu1,uv2) : VertexColor surf,v2,r,g,b,a2
		v3=AddVertex(surf,x2, 0,z2,uu2,uv2) : VertexColor surf,v3,r,g,b,a2
		v4=AddVertex(surf,x1, h,z1,uu1,uv3) : VertexColor surf,v4,r,g,b,a1
		v5=AddVertex(surf,x2, h,z2,uu2,uv3) : VertexColor surf,v5,r,g,b,a1
		
		; Add triangles
		AddTriangle surf,v0,v1,v3
		AddTriangle surf,v3,v2,v0
		AddTriangle surf,v2,v5,v4
		AddTriangle surf,v5,v2,v3
		
		; increase angle
		ang1=ang1+inc
		
	Wend
	
	EntityFX mesh,fx
	
	Return mesh
	
End Function


; -----------------------------------------------------------------------------------------------
; Update game logic, check for user input
; -----------------------------------------------------------------------------------------------
Function BT_UpdateGame()
	
	; check for User Input
	BT_Switch=False
	BT_CheckInput()
	
	; Update Lights
	BT_UpdateScene()
	
	; Player Position on Minimap
	If BT_ShowMinimap Then BT_UpdateMinimap()
	
	; ground
	If BT_ShowGround=1 Then ShowEntity BT_Ground Else HideEntity BT_Ground
	
	; wireframe
	WireFrame BT_ShowWireframe
	
	; haze
	If BT_ShowHaze=1 Then ShowEntity BT_Haze Else HideEntity BT_Haze
	
	; lights
	If BT_ShowLights=0 Then
		HideEntity BT_SunLightPivot
		HideEntity BT_MoonLightPivot
		HideEntity BT_SunPivot
		HideEntity BT_MoonPivot
	Else
		ShowEntity BT_SunLightPivot
		ShowEntity BT_MoonLightPivot
		ShowEntity BT_SunPivot
		ShowEntity BT_MoonPivot
	EndIf
	
	; brightness
	If BT_ShowBrightness=0 Then HideEntity BT_SunGlow Else ShowEntity BT_SunGlow
	
	; ocean
	If BT_ShowOcean=0 Then
		HideEntity BT_Ocean
		HideEntity BT_Shore
	Else
		ShowEntity BT_Ocean
		ShowEntity BT_Shore
	EndIf
	
	; minimap
	If BT_ShowMinimap=0 Then
		HideEntity BT_Minimap
		HideEntity BT_Minimap_Player
		HideEntity BT_Minimap_Frustum
	Else 
		ShowEntity BT_Minimap
		ShowEntity BT_Minimap_Player
		ShowEntity BT_Minimap_Frustum
	EndIf
	
	; sky
	If BT_ShowSky=0 Then
		HideEntity BT_Stratosphere
		HideEntity BT_Sky
		HideEntity BT_Starsphere
	Else
		ShowEntity BT_Stratosphere
		ShowEntity BT_Sky
		ShowEntity BT_Starsphere
	EndIf
	
	; terrain
	If BT_ShowMeshTiles Then ShowEntity QTS_Terrain Else HideEntity QTS_Terrain
	
	; camera
	CameraFogMode BT_Camera,BT_ShowFog
	CameraRange BT_Camera,BT_CameraMinRange,BT_Scale*BT_CameraMaxRangeMulti
	CameraFogRange BT_Camera,BT_FogMinRange,BT_Scale*BT_FogMaxRangeMulti
	
End Function


; -----------------------------------------------------------------------------------------------
; creates a moon sphere and photographs it to a quad texture
; -----------------------------------------------------------------------------------------------
Function BT_InitMoon()
	
	Local sphere%,light%
	Local tempcam%,x%,y%
	Local buffer1%,buffer2%
	Local rgb%,r%,g%,b%,a%
	
	sphere%=CreateSphere(32)
	EntityTexture sphere,BT_Texture_MoonSphere
	EntityFX sphere,2+8
	ScaleEntity sphere,1,1,1
	PositionEntity sphere,0,-10000,0
	
	AmbientLight 2,2,2
	light=CreateLight(1,sphere)
	PositionEntity light,0,0,0
	MoveEntity light,16,0,0
	PointEntity light,sphere
	LightRange light,16
	
	RotateEntity sphere,20,135,0
	TurnEntity sphere,0,BT_MoonPhase,0
	
	tempcam=CreateCamera()
	PositionEntity tempcam,0,-10000,0
	MoveEntity tempcam,0,0,2
	PointEntity tempcam,sphere
	CameraViewport tempcam,0,0,BT_MoonTextureSize,BT_MoonTextureSize
	HideEntity BT_SunLightPivot
	HideEntity BT_MoonLightPivot
	RenderWorld
	ShowEntity BT_MoonLightPivot
	ShowEntity BT_SunLightPivot
	
	; normally a texture with alpha flag would be created here, but this is a
	; workaround to prevent a strange createtexture alpha bug which leads to
	; disappearing textures - if loaded as texture they won't vanish :-)
	; if you change the moon texture size be sure to change the size of the
	; source texture file, too!
	buffer1=TextureBuffer(BT_Texture_MoonQuad1)
	buffer2=TextureBuffer(BT_Texture_MoonQuad2)
	
	LockBuffer buffer1
	LockBuffer buffer2
	LockBuffer BackBuffer()
	
	For y=0 To BT_MoonTextureSize-1
		
		For x=0 To BT_MoonTextureSize-1
			
			rgb=ReadPixelFast(x,y,BackBuffer())
			a=255
			
			r=(rgb And $ff0000)/$10000
			g=(rgb And $ff00)/$100
			b=(rgb And $ff)
			
			If r=0 And g=0 And b=0 Then a=0
			
			rgb=a*$1000000+r*$10000+g*$100+b
			WritePixelFast x,y,rgb,buffer1
			
			rgb=a*$1000000+255*$10000+255*$100+255
			WritePixelFast x,y,rgb,buffer2
			
		Next
		
	Next
	
	UnlockBuffer BackBuffer()
	UnlockBuffer buffer2
	UnlockBuffer buffer1
	
	FreeEntity tempcam
	FreeEntity sphere
	
End Function


; -----------------------------------------------------------------------------------------------
; Converts FOV (Field of View) angle to Camerazoom value
; -----------------------------------------------------------------------------------------------
Function BT_SetFOV#(angle#)
	
	Return 1.0/Tan(angle/2.0)
	
End Function


; -----------------------------------------------------------------------------------------------
; Set player to a given position and aligns him to the exact height there
; -----------------------------------------------------------------------------------------------
Function BT_InitPlayer#(x#,z#)
	
	PositionEntity BT_Player,x,0,z
	Local y#=BT_PickBelow(BT_Player,BT_Scale)
	
	PositionEntity BT_Player,x,y,z
	PositionEntity BT_Camera,x,y,z
	
	Return y
	
End Function


; -----------------------------------------------------------------------------------------------
; Moves player to the given position
; -----------------------------------------------------------------------------------------------
Function BT_BeamPlayerTo#(x#,z#)
	
	PositionEntity BT_Player,x,0,z
	Local y#=BT_PickBelow(BT_Player,BT_Scale)
	PositionEntity BT_Player,x,y,z
	
	Return y
	
End Function


; -----------------------------------------------------------------------------------------------
; Create a real minimap using a temporary cam from bird's eye view
; -----------------------------------------------------------------------------------------------
Function BT_CreateMinimap()
	
	Local tempcam%,surf%,minitex%
	Local oldalpha#,oldsunangle#,oldmoonangle#,oldsunlight#,oldmoonlight#
	
	; Temporary camera
	tempcam=CreateCamera()
	PositionEntity tempcam,0,BT_Scale,0
	CameraRange tempcam,1,BT_Scale*2
	RotateEntity tempcam,90,0,0
	CameraViewport tempcam,0,0,BT_MinimapTextureSize,BT_MinimapTextureSize
	CameraZoom tempcam,1.0/BT_HalfScale
	CameraClsColor tempcam,128,128,128
	CameraProjMode tempcam,2
	
	; change detail settings
	ScaleTexture BT_Texture_Detailmap1,1,1
	ScaleTexture BT_Texture_Detailmap2,1,1
	
	; store current values and set default values
	oldalpha=BT_WaterAlpha : BT_WaterAlpha=0.5
	oldsunangle=BT_SunAngle : BT_SunAngle=180
	oldmoonangle=BT_MoonAngle : BT_MoonAngle=180
	oldsunlight=BT_SunLightIntensity : BT_SunLightIntensity=20
	oldmoonlight=BT_MoonLightIntensity : BT_MoonLightIntensity=5
	
	; Render fullbright scene for a nice minimap
	BT_UpdateScene()
	AmbientLight 255,255,255
	RenderWorld
	
	; reset detail settings
	ScaleTexture BT_Texture_Detailmap2,1.0/BT_DetailScale2,1.0/BT_DetailScale2
	ScaleTexture BT_Texture_Detailmap1,1.0/BT_DetailScale1,1.0/BT_DetailScale1
	
	; reset stored values
	BT_WaterAlpha=oldalpha
	BT_SunAngle=oldsunangle
	BT_MoonAngle=oldmoonangle
	BT_SunLightIntensity=oldsunlight
	BT_MoonLightIntensity=oldmoonlight
	
	; Create a new texture
	minitex=CreateTexture(BT_MinimapTextureSize,BT_MinimapTextureSize,16+32+256)
	CopyRect 0,0,BT_MinimapTextureSize,BT_MinimapTextureSize,0,0,BackBuffer(),TextureBuffer(minitex)
	
	; free unused entity
	Cls
	FreeEntity tempcam
	
	; Create a map quad in front of the camera
	BT_Minimap=BT_CreateQuad(255,255,255,1.0,1+2+8+32)
	EntityParent BT_Minimap,BT_Camera
	PositionEntity BT_Minimap,-(BT_ScreenWidth/2)+(BT_MinimapSize/2)+BT_ScreenWidth-BT_MinimapSize+BT_MinimapOffset,(BT_ScreenHeight/2)-(BT_MinimapSize/2)+BT_MinimapOffset,BT_ScreenWidth/2*BT_SetFOV(BT_CameraFOV)
	ScaleEntity BT_Minimap,BT_MinimapSize/2,BT_MinimapSize/2,1
	EntityTexture BT_Minimap,minitex,0,1
	EntityOrder BT_Minimap,-1
	RotateEntity BT_Minimap,0,180,0
	
	; Minimap Player position quad
	BT_Minimap_Player=BT_CreateQuad(BT_MinimapPlayerR,BT_MinimapPlayerG,BT_MinimapPlayerB,1.0,1+2+32)
	EntityParent BT_Minimap_Player,BT_Camera
	ScaleEntity BT_Minimap_Player,2,2,1
	EntityOrder BT_Minimap_Player,-100
	RotateEntity BT_Minimap_Player,0,180,0
	
	; Minimap Frustum triangle
	BT_Minimap_Frustum=CreateMesh()
	surf=CreateSurface(BT_Minimap_Frustum)
	EntityFX BT_Minimap_Frustum,1+2+32
	EntityParent BT_Minimap_Frustum,BT_Camera
	EntityOrder BT_Minimap_Frustum,-50
	
	; add frustum dummy vertices
	AddVertex(surf,0,0,0)
	AddVertex(surf,0,0,0)
	AddVertex(surf,0,0,0)
	
	; color these vertices
	VertexColor surf,0,BT_MinimapFrustumR,BT_MinimapFrustumG,BT_MinimapFrustumB,BT_MinimapFrustumA
	VertexColor surf,1,BT_MinimapFrustumR,BT_MinimapFrustumG,BT_MinimapFrustumB,0.0
	VertexColor surf,2,BT_MinimapFrustumR,BT_MinimapFrustumG,BT_MinimapFrustumB,0.0
	
	; add frustum dummy triangle
	AddTriangle surf,0,2,1
	
End Function


; -----------------------------------------------------------------------------------------------
; Check User Input (Keyboard / Mouse)
; -----------------------------------------------------------------------------------------------
Function BT_CheckInput()
	
	Local mwheel%
	
	; F1: show help (and replaces Info)
	If KeyHit(59) Then BT_ShowHelp=1-BT_ShowHelp : BT_ShowInformation=0
	
	; Key Q/W: change light angle
	BT_ManualUpdate=False
	If KeyDown(16) Then
		BT_SunAngle=BT_SunAngle-(1.0/10)
		BT_MoonAngle=BT_MoonAngle-(1.0/10)
		BT_ManualUpdate=True
	EndIf
	If KeyDown(17) Then
		BT_SunAngle=BT_SunAngle+(1.0/10)
		BT_MoonAngle=BT_MoonAngle+(1.0/10)
		BT_ManualUpdate=True
	EndIf
	
	; Key 1-9: predefined angle 0-180 in 22.5 steps
	If KeyDown(2)  Then BT_SunAngle= 90.0 : BT_MoonAngle=BT_SunAngle
	If KeyDown(3)  Then BT_SunAngle=112.5 : BT_MoonAngle=BT_SunAngle
	If KeyDown(4)  Then BT_SunAngle=135.0 : BT_MoonAngle=BT_SunAngle
	If KeyDown(5)  Then BT_SunAngle=157.5 : BT_MoonAngle=BT_SunAngle
	If KeyDown(6)  Then BT_SunAngle=180.0 : BT_MoonAngle=BT_SunAngle
	If KeyDown(7)  Then BT_SunAngle=202.5 : BT_MoonAngle=BT_SunAngle
	If KeyDown(8)  Then BT_SunAngle=225.0 : BT_MoonAngle=BT_SunAngle
	If KeyDown(9)  Then BT_SunAngle=247.5 : BT_MoonAngle=BT_SunAngle
	If KeyDown(10) Then BT_SunAngle=270.0 : BT_MoonAngle=BT_SunAngle
	If KeyDown(11) Then BT_SunAngle=  0.0 : BT_MoonAngle=BT_SunAngle
	
	; Backspace = Save screenshot
	BT_SaveScreenshot=False : If KeyHit(14) Then BT_SaveScreenshot=True
	
	; Alt GR = show/hide FPS
	If KeyHit(184) Then BT_ShowFPS=1-BT_ShowFPS
	
	; Space = Wireframe on/off
	If KeyHit(57) Then BT_ShowWireframe=1-BT_ShowWireframe
	
	; F = Fog on/off
	If KeyHit(33) Then BT_ShowFog=1-BT_ShowFog
	
	; G = Ground on/off
	If KeyHit(34) Then BT_ShowGround=1-BT_ShowGround
	
	; A = Align on/off
	If KeyHit(30) Then BT_PlayerAlign=1-BT_PlayerAlign
	
	; T = Twinkle on/off
	If KeyHit(20) Then BT_ShowStarTwinkle=1-BT_ShowStarTwinkle
	
	; H = Haze on/off
	If KeyHit(35) Then BT_ShowHaze=1-BT_ShowHaze
	
	; I = show/hide Infos
	If KeyHit(23) Then BT_ShowInformation=1-BT_ShowInformation : BT_ShowHelp=0
	
	; ENTER = switch camera mode
	If KeyHit(28) Or MouseHit(3) Then BT_CameraMode=1-BT_CameraMode : BT_Switch=True
	
	; L = show/hide Light sources
	If KeyHit(38) Then BT_ShowLights=1-BT_ShowLights
	
	; B = show/hide Brightness
	If KeyHit(48) Then BT_ShowBrightness=1-BT_ShowBrightness
	
	; S = show/hide Sky
	If KeyHit(31) Then BT_ShowSky=1-BT_ShowSky
	
	; O = show/hide Ocean
	If KeyHit(24) Then BT_ShowOcean=1-BT_ShowOcean
	
	; P = show/hide Places
	If KeyHit(25) Then BT_ShowPlaces=1-BT_ShowPlaces
	
	; M = show/hide Minimap
	If KeyHit(50) Then BT_ShowMinimap=1-BT_ShowMinimap
	
	; TAB = show/hide mesh terrain
	If KeyHit(15) Then BT_ShowMeshTiles=1-BT_ShowMeshTiles
	
	; Mousewheel: change FOV angle
	mwheel=MouseZSpeed()
	If mwheel<0 Then
		BT_CameraFOV=BT_CameraFOV+5
		If BT_CameraFOV>150 Then BT_CameraFOV=150
		CameraZoom BT_Camera,BT_SetFOV(BT_CameraFOV)
	EndIf
	If mwheel>0 Then
		BT_CameraFOV=BT_CameraFOV-5
		If BT_CameraFOV<30 Then BT_CameraFOV=30
		CameraZoom BT_Camera,BT_SetFOV(BT_CameraFOV)
	EndIf
	If mwheel<>0 Then PositionEntity BT_Minimap,-(BT_ScreenWidth/2)+(BT_MinimapSize/2)+BT_ScreenWidth-BT_MinimapSize+BT_MinimapOffset,(BT_ScreenHeight/2)-(BT_MinimapSize/2)+BT_MinimapOffset,BT_ScreenWidth/2*BT_SetFOV(BT_CameraFOV)
	
End Function


; -----------------------------------------------------------------------------------------------
; Init additional elements like cam, light, water
; -----------------------------------------------------------------------------------------------
Function BT_InitScene()
	
	Local scale#
	
	BT_Skypivot=CreatePivot()
	
	; Create Player
	BT_Player=LoadAnimMesh(BT_ModelPath+"dwarf1.b3d")
	ScaleEntity BT_Player,(1.0/32)*BT_PlayerHeight,(1.0/32)*BT_PlayerHeight,(1.0/32)*BT_PlayerHeight
	TurnEntity BT_Player,0,-BT_PlayerStartR,0
	BT_PlayerHead=CreatePivot()
	EntityParent BT_PlayerHead,BT_Player,1
	PositionEntity BT_PlayerHead,0,48,0
	BT_PlayerCenter=CreatePivot(BT_Player)
	BT_PlayerPivot=CreatePivot()
	EntityParent BT_PlayerPivot,BT_PlayerCenter,1
	PositionEntity BT_PlayerPivot,0,BT_CameraBT_DistanceY,-BT_CameraBT_DistanceZ
	ExtractAnimSeq BT_Player,292,325		; 1=idle
	ExtractAnimSeq BT_Player,2,14			; 2=walk
	ExtractAnimSeq BT_Player,16,26			; 3=run
	ExtractAnimSeq BT_Player, 16, 26		; 4=jump
	
	; Create Camera
	BT_Camera=CreateCamera()
	EntityType BT_Camera,1
	EntityRadius BT_Camera,BT_CameraCollisionRadius
	
	; Lightpivots
	BT_SunLightPivot=CreatePivot()
	BT_MoonLightPivot=CreatePivot()
	
	; Sun/Moon Pivot
	BT_SunPivot=CreatePivot()
	BT_MoonPivot=CreatePivot()
	
	; create main pivot for all places
	BT_PlacesPivot=CreatePivot()
	
	; Suns
	BT_Sun1=BT_CreateQuad(255,255,255,1.0,1+2+8)
	EntityTexture BT_Sun1,BT_Texture_Sun1
	EntityParent BT_Sun1,BT_SunPivot
	PositionEntity BT_Sun1,-128,0,0
	BT_Sun2=BT_CreateQuad(255,192,192,0.5,1+2+8)
	EntityTexture BT_Sun2,BT_Texture_Sun2
	EntityParent BT_Sun2,BT_SunPivot
	PositionEntity BT_Sun2,-128,0,0
	EntityBlend BT_Sun2,3
	BT_Sun3=BT_CreateQuad(255,192,128,0.25,1+2+8)
	EntityTexture BT_Sun3,BT_Texture_Sun2
	EntityParent BT_Sun3,BT_SunPivot
	PositionEntity BT_Sun3,-128,0,0
	EntityBlend BT_Sun3,3
	
	; Sunshines
	BT_SunBright1=BT_CreateQuad(255,192,96,1,1+2+8+32)
	EntityParent BT_SunBright1,BT_SunPivot
	PositionEntity BT_SunBright1,-128,0,0
	EntityTexture BT_SunBright1,BT_Texture_Sunglow1,0,1
	BT_SunBright2=BT_CreateQuad(0,0,0,0,2+8+32)
	EntityParent BT_SunBright2,BT_SunPivot
	PositionEntity BT_SunBright2,-128,0,0
	EntityTexture BT_SunBright2,BT_Texture_Sunglow2,0,1
	
	; Moons
	BT_Moon1=BT_CreateQuad(0,0,0,0,1+2+8)
	EntityParent BT_Moon1,BT_MoonPivot
	PositionEntity BT_Moon1,-128,0,0
	EntityTexture BT_Moon1,BT_Texture_MoonQuad1
	EntityBlend BT_Moon1,3
	BT_Moon2=BT_CreateQuad(0,0,0,0,1+2+8)
	EntityParent BT_Moon2,BT_MoonPivot
	PositionEntity BT_Moon2,-128,0,0
	EntityTexture BT_Moon2,BT_Texture_MoonQuad2
	
	; Sunglow
	BT_SunGlow=BT_CreateQuad(255,255,255,1,1+2+8+32)
	EntityTexture BT_SunGlow,BT_Texture_Sun2
	EntityParent BT_SunGlow,BT_SunPivot
	PositionEntity BT_SunGlow,-128,0,0
	
	; Moonshines
	BT_MoonBright1=BT_CreateQuad(0,0,0,0,1+2+8+32)
	EntityParent BT_MoonBright1,BT_MoonPivot
	PositionEntity BT_MoonBright1,-128,0,0
	EntityTexture BT_MoonBright1,BT_Texture_Sunglow2,0,1
	EntityBlend BT_MoonBright1,1
	BT_MoonBright2=BT_CreateQuad(0,0,0,0,1+2+8+32)
	EntityParent BT_MoonBright2,BT_MoonPivot
	PositionEntity BT_MoonBright2,-128,0,0
	EntityTexture BT_MoonBright2,BT_Texture_Sunglow2,0,1
	EntityBlend BT_MoonBright2,5
	
	; Sunlight source
	BT_SunLight=CreateLight(BT_SunLightType)
	EntityParent BT_SunLight,BT_SunLightPivot
	PositionEntity BT_SunLight,-BT_Scale*10,0,0
	
	; Moonlight source
	BT_MoonLight=CreateLight(BT_MoonLightType)
	EntityParent BT_MoonLight,BT_MoonLightPivot
	PositionEntity BT_MoonLight,-BT_Scale*10,0,0
	
	; Shore
	BT_Shore=BT_CreatePatch(BT_ShorePatchResolution,1.0/BT_ShorePatchResolution,0,0,0,255,255,255,0.5,2+16+32)
	If BT_IsIsland Then
		EntityTexture BT_Shore,BT_Texture_HorizonMask,0,1
		ScaleEntity BT_Shore,BT_Scale*2,1,BT_Scale*2
	Else
		ScaleEntity BT_Shore,BT_Scale,1,BT_Scale
	EndIf
	EntityTexture BT_Shore,BT_Texture_Water1,0,2
	EntityTexture BT_Shore,BT_Texture_Water2,0,3
	EntityBlend BT_Shore,3
	
	; Water
	BT_Ocean=BT_CreatePatch(BT_OceanPatchResolution,1.0/BT_OceanPatchResolution,0,0,0,0,0,0,0,2+16+32)
	If BT_IsIsland Then
		EntityTexture BT_Ocean,BT_Texture_HorizonMask,0,1
		ScaleEntity BT_Ocean,BT_Scale*2,1,BT_Scale*2
	Else
		ScaleEntity BT_Ocean,BT_Scale,1,BT_Scale
	EndIf
	
	; Ground
	BT_Ground=BT_CreatePatch(BT_GroundPatchResolution,1.0/BT_GroundPatchResolution,0,0,0,0,0,0,1,2+32)
	PositionEntity BT_Ground,0,QTS_MinHeight*1.1,0
	EntityTexture BT_Ground,BT_Texture_HorizonMask,0,1
	
	; Strato Ice Clouds
	BT_Stratosphere=BT_CreatePatch(16,1.0/16,0,0,0,0,0,0,1.0,2+8+16+32)
	BT_DeformMesh(BT_Stratosphere,BT_DomeBulge,17,17,256.0*16,255,255,255,False)
	ScaleEntity BT_Stratosphere,128,128,128
	EntityParent BT_Stratosphere,BT_Skypivot
	UpdateNormals BT_Stratosphere
	EntityTexture BT_Stratosphere,BT_Texture_Clouds3,0,1
	
	; Sky with Clouds
	BT_Sky=BT_CreatePatch(16,1.0/16,0,0,0,0,0,0,1.0,2+8+16+32)
	BT_DeformMesh(BT_Sky,BT_DomeBulge,17,17,256.0*16,255,255,255,False)
	ScaleEntity BT_Sky,128,128,128
	EntityParent BT_Sky,BT_Skypivot
	UpdateNormals BT_Sky
	EntityTexture BT_Sky,BT_Texture_Clouds1,0,2
	EntityTexture BT_Sky,BT_Texture_Clouds2,0,3
	
	; Horizon Haze
	BT_Haze=BT_InitHaze(1,BT_HazeHeight,BT_Hazesegments,1+2+8+32,255,255,255,1,1)
	EntityTexture BT_Haze,BT_Texture_HazeGradient,0,1
	ScaleEntity BT_Haze,128,128,128
	EntityParent BT_Haze,BT_Skypivot
	
	; Star Hemisphere with Fix stars
	BT_Starsphere=BT_InitStarSphere(BT_Stars,BT_StarSizeMin,BT_StarSizeMax,BT_FixStarsProportion,BT_StarMinBrightness,BT_StarMaxBrightness,16,1.0,1+2+8+32)
	EntityTexture BT_Starsphere,BT_Texture_SingleStar,0,1
	ScaleEntity BT_Starsphere,128,128,128
	EntityParent BT_Starsphere,BT_Skypivot
	
	; scale sky objects
	scale=BT_SkyObjectsMulti
	ScaleEntity BT_Sun1,		scale*0.25,scale*0.25,scale*0.25
	ScaleEntity BT_Sun2,		scale*0.50,scale*0.50,scale*0.50
	ScaleEntity BT_Moon1,		scale*0.33,scale*0.33,scale*0.33
	ScaleEntity BT_Moon2,		scale*0.33,scale*0.33,scale*0.33
	ScaleEntity BT_MoonBright1,	scale*2.00,scale*2.00,scale*2.00
	ScaleEntity BT_MoonBright2,	scale*4.00,scale*4.00,scale*4.00
	
	; Reorder sky entities
	EntityOrder BT_Starsphere,50
	EntityOrder BT_Moon2,41
	EntityOrder BT_Moon1,40
	EntityOrder BT_SunGlow,33
	EntityOrder BT_Stratosphere,32
	EntityOrder BT_Sky,31
	EntityOrder BT_Haze,30
	EntityOrder BT_MoonBright1,24
	EntityOrder BT_MoonBright2,23
	EntityOrder BT_SunBright1,22
	EntityOrder BT_SunBright2,21
	EntityOrder BT_Sun3,12
	EntityOrder BT_Sun2,11
	EntityOrder BT_Sun1,10
	
End Function


; -----------------------------------------------------------------------------------------------
; Updates a Patch with new ARGB
; -----------------------------------------------------------------------------------------------
Function BT_UpdatePatch(mesh%,r%,g%,b%,a#,usealpha%=False,usevertexcolors%=False)
	
	Local surf%=GetSurface(mesh,1)
	Local v%
	
	For v=0 To CountVertices(surf)-1
		If usealpha Then a=VertexAlpha(surf,v)
		If usevertexcolors Then
			r=VertexRed(surf,v)
			g=VertexGreen(surf,v)
			b=VertexBlue(surf,v)
		EndIf
		
		VertexColor surf,v,r,g,b,a
	Next
	
End Function


; -----------------------------------------------------------------------------------------------
; Updates light FX by angle
; -----------------------------------------------------------------------------------------------
Function BT_UpdateScene()
	
	Local sunsize#,time%,scale#,xx#,yy#,moonlight%
	Local aspectx#,aspecty#,aspectz#
	
	; small increase of sun and moon angle (only if no manual change is running)
	If Not BT_ManualUpdate Then
		BT_SunAngle=BT_SunAngle+(1.0/250)
		BT_MoonAngle=BT_MoonAngle+(1.0/250)
	EndIf
	
	; Limit angle to 0...360 degrees
	BT_SunAngle=BT_SunAngle Mod 360.0 : If BT_SunAngle<0 Then BT_SunAngle=360.0
	BT_MoonAngle=BT_MoonAngle Mod 360.0 : If BT_MoonAngle<0 Then BT_MoonAngle=360.0
	
	; calc values for time, sunsize and scale from current sunangle
	time=Int(BT_SunAngle*(BT_ColorSteps/360.0))
	sunsize=BT_Normalize(Sunsizes[time],0,255,0.0,1.75)
	scale=32.0
	
	; only continue if angle has been changed
	If BT_SunAngle<>BT_OldSunAngle Then
		
		; rotate light angle and point light sources/quads to pivot/cam
		RotateEntity BT_SunPivot,-BT_SunInclination,0,BT_SunAngle+90
		RotateEntity BT_MoonPivot,-BT_MoonInclination,0,BT_MoonAngle-90
		RotateEntity BT_SunLightPivot,-BT_SunInclination,0,BT_SunAngle+90
		RotateEntity BT_MoonLightPivot,-BT_MoonInclination,0,BT_MoonAngle-90
		
		PointEntity BT_SunLight,BT_SunLightPivot
		PointEntity BT_MoonLight,BT_MoonLightPivot
		PointEntity BT_Moon1,BT_Camera
		PointEntity BT_Moon2,BT_Camera
		PointEntity BT_Sun1,BT_Camera
		PointEntity BT_Sun2,BT_Camera
		PointEntity BT_Sun3,BT_Camera
		PointEntity BT_SunGlow,BT_Camera
		PointEntity BT_SunBright1,BT_Camera,1
		PointEntity BT_SunBright2,BT_Camera,1
		PointEntity BT_MoonBright1,BT_Camera
		PointEntity BT_MoonBright2,BT_Camera
		
		; Set Gradient Colors
		AmbientLight AmbientR[time],AmbientG[time],AmbientB[time]
		
		; update cam
		CameraClsColor BT_Camera,CLScolorR[time],CLScolorG[time],CLScolorB[time]
		CameraFogColor BT_Camera,HazeColR[time],HazeColG[time],HazeColB[time]
		
		; update lights
		moonlight=MoonAlpha[time]*(90-BT_MoonPhase)/180.0
		LightColor BT_SunLight,LightR[time],LightG[time],LightB[time]
		LightColor BT_MoonLight,moonlight,moonlight*1.25,moonlight*1.5
		LightRange BT_SunLight,SunLightRange[time]/255.0*BT_SunLightIntensity*BT_Scale
		LightRange BT_MoonLight,MoonLightRange[time]/255.0*BT_MoonLightIntensity*BT_Scale*(MoonAlpha[time]/255.0)
		
		; update patches / quads
		BT_UpdatePatch(BT_Moon1,255,255,255,MoonAlpha[time]/255.0)
		BT_UpdatePatch(BT_Moon2,CLScolorR[time],CLScolorG[time],CLScolorB[time],1)
		BT_UpdatePatch(BT_MoonBright1,255,255,255,(MoonAlpha[time]/255.0)*(90-BT_MoonPhase)/135.0)
		BT_UpdatePatch(BT_MoonBright2,128,192,255,(MoonAlpha[time]/255.0)*(90-BT_MoonPhase)/270.0)
		BT_UpdatePatch(BT_Haze,HazeColR[time],HazeColG[time],HazeColB[time],1,True,False)
		BT_UpdatePatch(BT_Ocean,OceanR[time],OceanG[time],OceanB[time],BT_WaterAlpha)
		BT_UpdatePatch(BT_SunBright2,SunLightR[time],SunLightG[time],SunLightB[time],0.75*sunsize^sunsize)
		BT_UpdatePatch(BT_Starsphere,255,255,255,StarAlpha[time]/255.0,False,True)
		
		; Sun aspect
		aspectx#=SunAspectX[time]/16.0
		aspecty#=SunAspectY[time]/16.0
		aspectz#=SunAspectZ[time]/16.0
		ScaleEntity BT_SunBright1,aspectx*BT_SkyObjectsMulti*0.5,aspecty*BT_SkyObjectsMulti*0.5,aspectz*BT_SkyObjectsMulti*0.5
		ScaleEntity BT_SunBright2,aspectx*BT_SkyObjectsMulti*1.0,aspecty*BT_SkyObjectsMulti*1.0,aspectz*BT_SkyObjectsMulti*1.0
		
		; adaptive ground resize to prevent ugly horizon lines
		xx=1+Exp(1.0/BT_CamY*50) : If xx>20 Or BT_CamY<0 Then xx=20
		yy=(1-(1.0/Exp(BT_CamY*0.001)))
		ScaleEntity BT_Ground,BT_Scale*xx,1,BT_Scale*xx
		PositionEntity BT_Ground,0,QTS_MinHeight*1.1,0
		
		; scale sky objects
		ScaleEntity BT_Sun3,scale*sunsize^2,scale*sunsize^2,scale*sunsize^2
		
		; Water movement
		If BT_ShoreMove Then
			BT_ShoreMove1=(BT_ShoreMove1+(0.2*BT_ShoreSpeed)) Mod 360
			BT_ShoreMove2=(BT_ShoreMove2+(0.1*BT_ShoreSpeed)) Mod 360
		EndIf
		PositionEntity BT_Shore,0,BT_WaterLevel+Sin(BT_ShoreMove1)+(Sin(BT_ShoreMove2)/10.0),0
		PositionEntity BT_Ocean,0,BT_WaterLevel+Sin(BT_ShoreMove1)+(Sin(BT_ShoreMove2)/10.0),0
		
		; Wave simulation
		BT_WaveMove1=BT_SunAngle/180.0
		BT_WaveMove2=BT_SunAngle/90.0
		PositionTexture BT_Texture_Water1,-BT_WaveMove2*BT_WaterSpeed,-BT_WaveMove2*BT_WaterSpeed
		PositionTexture BT_Texture_Water2,-BT_WaveMove1*BT_WaterSpeed,BT_WaveMove1*BT_WaterSpeed
		
		; Cloud movement
		BT_CloudMove=BT_SunAngle/360.0
		PositionTexture BT_Texture_Clouds1,-BT_CloudMove*BT_CloudSpeed,0
		PositionTexture BT_Texture_Clouds2,-BT_CloudMove*BT_CloudSpeed,0
		PositionTexture BT_Texture_Clouds3,-BT_CloudMove*BT_CloudSpeed,0
		
		; Star twinkle
		If BT_ShowStarTwinkle Then BT_UpdateStarTwinkle()
		
		BT_OldSunAngle=BT_SunAngle
		
	EndIf
	
	; Sun brightness FX
	If BT_ShowBrightness Then BT_UpdateBrightness()

End Function


; -----------------------------------------------------------------------------------------------
; Animates star twinkle
; -----------------------------------------------------------------------------------------------
Function BT_UpdateStarTwinkle()
	
	Local s.startwinkle
	Local surf%=GetSurface(BT_Starsphere,1)
	For s.startwinkle = Each startwinkle
		s\brightness=(s\brightness+s\frequency) Mod 180
		
		BT_UpdateStar(surf,s\id*2,(Sin(s\brightness)*(s\sourcecolor/2))+(s\sourcecolor/2))
	Next
		
End Function


; -----------------------------------------------------------------------------------------------
; Updates Sun Brightness FX
; -----------------------------------------------------------------------------------------------
Function BT_UpdateBrightness()
	
	Local sx#,sy#,sz#
	Local mx#,my#,mz#
	Local brightness#,a#,x#,y#
	
	; get sun quad position in 3D space
	sx=EntityX(BT_Sun1,1)
	sy=EntityY(BT_Sun1,1)
	sz=EntityZ(BT_Sun1,1)
	CameraProject BT_Camera,sx,sy,sz
	
	; calculate 2D position of sun quad
	x=1-Abs(BT_Normalize(ProjectedX(),0,BT_ScreenWidth-1,-1,1))
	y=1-Abs(BT_Normalize(ProjectedY(),0,BT_ScreenHeight-1,-1,1))
	If x<0 Then x=0
	If y<0 Then y=0
	
	; exponential brightness
	brightness=(Exp(x)*Exp(y))
	
	; Normalize value and update sunglow quad size
	a=BT_Normalize(brightness,0,6,0.0,1)
	BT_UpdatePatch(BT_SunGlow,255,255,255,a,False,True)
	ScaleEntity BT_SunGlow,BT_BrightnessMulti*a,BT_BrightnessMulti*a,BT_BrightnessMulti*a
	
	; get moon quad position in 3D space
	mx=EntityX(BT_Moon1,1)
	my=EntityY(BT_Moon1,1)
	mz=EntityZ(BT_Moon1,1)
	CameraProject BT_Camera,mx,my,mz
	
	; calculate 2D position of sun quad
	x=1-Abs(BT_Normalize(ProjectedX(),0,BT_ScreenWidth-1,-1,1))
	y=1-Abs(BT_Normalize(ProjectedY(),0,BT_ScreenHeight-1,-1,1))
	If x<0 Then x=0
	If y<0 Then y=0
	
	; exponential brightness
	brightness=(Exp(x)*Exp(y))
	
	; Normalize value and update sunglow quad size
	a=BT_Normalize(brightness,0,6,0.25,1)
	ScaleEntity BT_MoonBright1,BT_BrightnessMulti*a*0.33,BT_BrightnessMulti*a*0.33,BT_BrightnessMulti*a*0.33
	ScaleEntity BT_MoonBright2,BT_BrightnessMulti*a,BT_BrightnessMulti*a,BT_BrightnessMulti*a
	
End Function


; -----------------------------------------------------------------------------------------------
; Updates a single star
; -----------------------------------------------------------------------------------------------
Function BT_UpdateStar(surf%,triangle%,col%)
	
	Local tri%,v0%,v1%,v2%
	
	For tri=triangle To triangle+1
		
		v0=TriangleVertex(surf,tri,0)
		v1=TriangleVertex(surf,tri,1)
		v2=TriangleVertex(surf,tri,2)
		VertexColor surf,v0,col,col,col,VertexAlpha(surf,v0)
		VertexColor surf,v1,col,col,col,VertexAlpha(surf,v1)
		VertexColor surf,v2,col,col,col,VertexAlpha(surf,v2)
		
	Next
	
End Function


; -----------------------------------------------------------------------------
; BT_Normalize a value
; -----------------------------------------------------------------------------
Function BT_Normalize#(value#=128.0,value_min#=0.0,value_max#=255.0,norm_min#=0.0,norm_max#=1.0)
	
	Return ((value#-value_min#)/(value_max#-value_min#))*(norm_max#-norm_min#)+norm_min#
	
End Function


; -----------------------------------------------------------------------------------------------
; Create a simple quad, with alpha and fx
; -----------------------------------------------------------------------------------------------
Function BT_CreateQuad(r%=255,g%=255,b%=255,alpha#=1.0,fx%=0,centered%=False)
	
	Local mesh%,surface%,v1%,v2%,v3%,v4%,s#
	
	If centered Then s#=0.5 Else s#=1.0
	
	mesh=CreateMesh()
	surface=CreateSurface(mesh)
	
	v1=AddVertex (surface,-s, s,0,1,0)
	v2=AddVertex (surface, s, s,0,0,0)
	v3=AddVertex (surface,-s,-s,0,1,1)
	v4=AddVertex (surface, s,-s,0,0,1)
	
	VertexColor surface,v1,r,g,b,alpha
	VertexColor surface,v3,r,g,b,alpha
	VertexColor surface,v2,r,g,b,alpha
	VertexColor surface,v4,r,g,b,alpha
	
	AddTriangle(surface,0,1,2)
	AddTriangle(surface,3,2,1)
	
	EntityFX mesh,fx
	
	FlipMesh mesh
	
	Return mesh
	
End Function


; -----------------------------------------------------------------------------------------------
; Create a simple patch with alpha and fx
; -----------------------------------------------------------------------------------------------
Function BT_CreatePatch(size%,scale#,px#,py#,pz#,r%,g%,b%,a#,fx%)
	
	Local x%,z%,v#,u#,v0%,v1%,v2%,v3%
	
	; create mesh and surface
	Local mesh%=CreateMesh()
	Local surf%=CreateSurface(mesh)
	
	For z=0 To size
		
		For x=0 To size
			
			; calculate uv coordinates that the texture fits to the tile
			u=x*1.0/size
			v=z*1.0/size*-1
			
			; set vertexposition
			BT_VertexBuffer(x,z)=AddVertex (surf,-((size)/2.0)+x,0.0,-((size)/2.0)+z,u,v)
			VertexColor surf,BT_VertexBuffer(x,z),r,g,b,a#
			
		Next
		
	Next
	
	; set triangles
	For z=0 To size-1
		
		For x=0 To size-1
			
			v0=BT_VertexBuffer(x,z)
			v1=BT_VertexBuffer(x+1,z)
			v2=BT_VertexBuffer(x+1,z+1)
			v3=BT_VertexBuffer(x,z+1)
			
			AddTriangle (surf,v0,v2,v1)
			AddTriangle (surf,v0,v3,v2)
			
		Next
		
	Next
	
	; position, scale and fx
	PositionEntity mesh,px,py,pz
	ScaleMesh mesh,scale,scale,scale
	EntityFX mesh,fx
	
	Return mesh
	
End Function


; -----------------------------------------------------------------------------------------------
; Mesh Deform, uses a heightmap for deformation
; -----------------------------------------------------------------------------------------------
Function BT_DeformMesh(mesh%,image%,sizex%,sizez%,divider#,r%,g%,b%,heightalpha=True)
	
	Local x%,z%,h#,index%
	
	Local surf%=GetSurface(mesh,1)
	Local buffer%=ImageBuffer(image)
	
	LockBuffer buffer
	
	For z=0 To sizex-1
		
		For x=0 To sizez-1
			
			index = x + (sizex*z)
			
			h=(ReadPixelFast(x,z,buffer) And $ff0000)/$10000
			
			VertexCoords surf,index,VertexX(surf,index),h/divider,VertexZ(surf,index)
			
			If heightalpha Then
				VertexColor surf,index,r,g,b,BT_Normalize(h,0,255,0.0,1.0)
			Else
				VertexColor surf,index,r,g,b,1
			EndIf
			
		Next
		
	Next
	
	UnlockBuffer buffer
	
End Function


; -----------------------------------------------------------------------------------------------
; Creates a smooth gradient out of a few data field RGB values and a percentage value
; -----------------------------------------------------------------------------------------------
Function BT_CreateGradient(colors%,steps%,inverse=False,R%[BT_ColorSteps],G%[BT_ColorSteps],B%[BT_ColorSteps])
	
	Dim BT_GradientPercent(colors)
	Dim BT_GradientRed(colors),BT_GradientGreen(colors),BT_GradientBlue(colors)
	
	Local i%,pos1%,pos2%,pdiff%
	Local rdiff%,gdiff%,bdiff%
	Local rstep#,gstep#,bstep#
	Local counter%=0
	
	; read data, inverse if set
	If inverse Then
		For i=colors To 1 Step -1
			Read BT_GradientPercent(i),BT_GradientRed(i),BT_GradientGreen(i),BT_GradientBlue(i)
			BT_GradientPercent(i)=100.0-BT_GradientPercent(i)
		Next
	Else
		For i=0 To colors-1
			Read BT_GradientPercent(i),BT_GradientRed(i),BT_GradientGreen(i),BT_GradientBlue(i)
		Next
	EndIf
	
	; gradient loop
	While counter<colors
		
		; convert percent to step position
		pos1=BT_GradientPercent(counter)*steps*1.0/100
		pos2=BT_GradientPercent(counter+1)*steps*1.0/100
		
		; calc delta and steps
		pdiff=pos2-pos1
		rdiff%=BT_GradientRed(counter)-BT_GradientRed(counter+1)
		gdiff%=BT_GradientGreen(counter)-BT_GradientGreen(counter+1)
		bdiff%=BT_GradientBlue(counter)-BT_GradientBlue(counter+1)
		rstep#=rdiff*1.0/pdiff
		gstep#=gdiff*1.0/pdiff
		bstep#=bdiff*1.0/pdiff
		
		; calc new colors and store to blitzarray
		For i=0 To pdiff
			
			R[pos1+i]=Int(BT_GradientRed(counter)-(rstep*i))
			G[pos1+i]=Int(BT_GradientGreen(counter)-(gstep*i))
			B[pos1+i]=Int(BT_GradientBlue(counter)-(bstep*i))
			
		Next
		
		; increase counter
		counter=counter+1
		
	Wend
	
End Function


; -----------------------------------------------------------------------------------------------
; Creates a star Hemisphere
; -----------------------------------------------------------------------------------------------
Function BT_InitStarSphere(stars%,min#,max#,fix#,mincol%,maxcol%,range#,scale#=1.0,fx%=False)
	
	Local star%,mesh%,surf%
	Local i%,size#,h%
	Local starangle#
	
	; create a single Star quad
	star=BT_CreateQuad()
	
	; create the hemisphere
	mesh = CreateMesh()
	surf = CreateSurface(mesh)
	If fx Then EntityFX mesh,fx
	
	; create stars
	For i=1 To stars
		
		; Add Star Twinkle ID and random brightness start
		Local s.startwinkle = New startwinkle
		s\id=i-1
		s\brightness=Rand(0,360)
		
		; create new surface if there are too many vertices
		If CountVertices(surf)>=65532 Then surf=CreateSurface(mesh)
		
		; Star size
		size=Rnd(min,max)*scale
		If Rnd(1)>(1.0-fix) Then size=max*1.5*scale
		ScaleEntity star,size,size,size
		
		; reposition quad to camera position
		PositionEntity star,BT_CamX,BT_CamY,BT_CamZ
		
		; turn starquad, move away and point back to cam
		RotateEntity star,0,0,0
		starangle=Rnd(0,Rnd(0,-90))
		TurnEntity star,starangle,Rnd(0,360),0
		MoveEntity star,0,0,range*scale
		PointEntity star,BT_Camera
		
		; Star Color
		If starangle>-10 Then h=BT_Normalize(starangle,0,-10,0,mincol) Else h=Rand(mincol,maxcol)
		
		; Star Twinkle Source Color
		s\sourcecolor=h
		s\frequency=Rnd(1,5)
		
		; Add star quad to star hemisphere
		BT_AddToMesh(star,mesh,h,h,h,1)
		
	Next
	
	; delete star quad
	FreeEntity star
	
	Return mesh
	
End Function


; -----------------------------------------------------------------------------------------------
; Add a mesh to another mesh (first surface only)
; -----------------------------------------------------------------------------------------------
Function BT_AddToMesh(source%,target%,r%,g%,b%,a#) 
	
	Local vert%[2],vr%[2],vg%[2],vb%[2],va#[2]
	Local oldvert%,i1%,i2%
	Local surf1%=GetSurface(source,1)
	Local surf2%=GetSurface(target,1)
	
	For i1=0 To CountTriangles(surf1)-1
		
		For i2=0 To 2
			
			oldvert = TriangleVertex(surf1,i1,i2)
			
			vr[i2]=r
			vg[i2]=g
			vb[i2]=b
			va[i2]=a
			
			TFormPoint VertexX(surf1,oldvert),VertexY(surf1,oldvert),VertexZ(surf1,oldvert),source,target 
			vert[i2]=AddVertex(surf2,TFormedX(),TFormedY(),TFormedZ(),VertexU(surf1,oldvert),VertexV(surf1,oldvert)) 
			VertexColor surf2,vert[i2],r,g,b,a
			
		Next 
		
		AddTriangle(surf2,vert[0],vert[1],vert[2])
		
	Next 
	
End Function


; -----------------------------------------------------------------------------------------------
; Free flight camera mode
; -----------------------------------------------------------------------------------------------
Function BT_FreeCam()
	
	Local movex#,movez#,dx#,dy#,dk#,dt%,s#,t%
	Local movespeed#,pitch#
	Local up%=0
	
	ShowPointer()
	
	BT_SpeedMultiplicator=1
	
	; LMB/RMB: move up / speed increase
	If MouseDown(1) Then up=1
	If KeyDown(54) Then BT_SpeedMultiplicator=25
	If MouseDown(2) Then BT_SpeedMultiplicator=100
	
	; Arrows = Move
	movex=KeyDown(205)-KeyDown(203)
	movez=KeyDown(200)-KeyDown(208)
	
	movespeed=BT_PlayerSpeed*BT_SpeedMultiplicator
	
	; smooth camera movement
	t=MilliSecs()
	dt=t-BT_DeltaTimeOld
	BT_DeltaTimeOld=t
	dk=Float(dt)/16.666
	s=0.1*dk
	dx=(BT_ScreenWidth/2-MouseX())*0.01*dk
	dy=(BT_ScreenHeight/2-MouseY())*0.01*dk
	TurnEntity BT_Camera,-dy,dx*s*8,0
	pitch=EntityPitch(BT_Camera,1)
	If pitch>85 Then pitch=85 Else If pitch<-85 Then pitch=-85
	RotateEntity BT_Camera,pitch,EntityYaw(BT_Camera,1),0,1	
	MoveEntity BT_Camera,movex*movespeed,up*movespeed,movez*movespeed
	
	; if switched between cameras point cam to player again
	If BT_Switch Then PointEntity BT_Camera,BT_PlayerHead : BT_Switch=False
	
	; in freeflight mode animate dwarf in idle mode
	If AnimSeq(BT_Player)<>1 Then Animate BT_Player,1,0.125,1,1
	
End Function


; -----------------------------------------------------------------------------------------------
; Gets current positions of Player and Camera and repositions Pivots to Camera Position
; -----------------------------------------------------------------------------------------------
Function BT_UpdatePositions()
	
	; get current Camera position
	BT_CamX=EntityX(BT_Camera)
	BT_CamY=EntityY(BT_Camera)
	BT_CamZ=EntityZ(BT_Camera)
	
	; get current Camera position
	BT_PlayerX=EntityX(BT_Player)
	BT_PlayerY=EntityY(BT_Player)
	BT_PlayerZ=EntityZ(BT_Player)
	
	; attach light and sky pivots to camera position (not vertical)
	PositionEntity BT_SunPivot,BT_CamX,BT_CamY,BT_CamZ
	PositionEntity BT_MoonPivot,BT_CamX,BT_CamY,BT_CamZ
	PositionEntity BT_Skypivot,BT_CamX,BT_CamY,BT_CamZ
	
End Function


; -----------------------------------------------------------------------------------------------
; Third person camera mode
; -----------------------------------------------------------------------------------------------
Function BT_ThirdCam()
	
	HidePointer()
	
	Local movex#,movez#,multi#,currentheight#
	Local sequence%=1,oldsequence%=1
	Local px#,py#,pz#,signed%
	
	; move and turn player input
	movex#=(KeyDown(203)-KeyDown(205))
	movez#=(KeyDown(200)-KeyDown(208))*0.25
	If movez<>0 Then multi=1.05 Else multi=0.95
	
	; SHIFT = increase player speed 10 times
	If MouseDown(2) Or KeyDown(54) Then BT_SpeedMultiplicator=3 Else BT_SpeedMultiplicator=1
	
	; increase turnspeed
	BT_PlayerTurnspeed=BT_PlayerTurnspeed+(movex*2.00)
	
	; switch animation sequence if necessary
	If movez<>0 Then sequence=2
	If sequence=2 And BT_SpeedMultiplicator>1 And BT_PlayerJumps=0 Then sequence=3
	
	; store old sequence
	oldsequence=sequence
	
	; on ground
	If BT_Playeronground=1 Or BT_PlayerJumps=0 Then
		BT_Gravity=BT_PlayerGravity
	EndIf
	
	; Jumping
	If MouseDown(1) And BT_Playeronground=1 Then
		If MilliSecs()>BT_PlayerJumpPause+200 Then
			BT_PlayerJumps=1
			BT_Antigravity=BT_PlayerGravity*1.25
		EndIf
	EndIf
	
	; (Anti)gravity
	If BT_PlayerJumps=1 Then
		BT_Antigravity=BT_Antigravity+(BT_PlayerGravity/100.0)
		If movez>=0 Then movez=(BT_PlayerSpeed*2) Else movez=-(BT_PlayerSpeed*2)
	EndIf
	If BT_Antigravity<0.01 Or BT_PlayerJumps=0 Then BT_Antigravity=0
	If BT_PlayerJumps=1 Then BT_Gravity=BT_Gravity*(1+(BT_PlayerGravity/20.0))
	If BT_Gravity>0 Then TranslateEntity BT_Player,0,-BT_Gravity+BT_Antigravity,0
	
	; limit turnspeed
	BT_PlayerTurnspeed=BT_PlayerTurnspeed*0.6
	If Abs(BT_PlayerTurnspeed)<0.0100 Then BT_PlayerTurnspeed=0
	
	; move player
	MoveEntity BT_Player,0,0,movez*BT_PlayerSpeed*BT_SpeedMultiplicator
	
	; aligns player to ground normal
	If BT_PlayerAlign Then
		AlignToVector BT_Player,BT_NX,BT_NY,BT_NZ,2,0.1
	Else
		RotateEntity BT_Player,0,EntityYaw(BT_Player),0
	EndIf
	
	; smart collision check
	currentheight#=BT_PickBelow(BT_Player,BT_Scale)
	
	; lift player to current height if below terrain, set flags
	If EntityY(BT_Player)-currentheight<=0 Then
		If BT_PlayerJumps=1 Then BT_PlayerJumpPause=MilliSecs()
		BT_Playeronground=1
		PositionEntity BT_Player,EntityX(BT_Player),currentheight+0.025,EntityZ(BT_Player)
		BT_Gravity=0
		BT_PlayerJumps=0
	Else
		BT_Playeronground=0
	EndIf
	
	; switch animation sequence if jumping else show stored sequence
	If BT_PlayerJumps=1 Then sequence=4 Else sequence=oldsequence
	
	If movez>=0 Then signed=1 Else signed=-1
	
	; play animation sequence
	If AnimSeq(BT_Player)<>1 And sequence=1 Then Animate BT_Player,1,0.125*signed,1,1
	If AnimSeq(BT_Player)<>2 And sequence=2 Then Animate BT_Player,1,0.25*signed,2,1
	If AnimSeq(BT_Player)<>3 And sequence=3 Then Animate BT_Player,1,0.25*signed,3,1
	If AnimSeq(BT_Player)<>4 And sequence=4 Then Animate BT_Player,1,0.1*signed,3,1
	
	; move around player
	TurnEntity BT_PlayerCenter,0,-MouseXSpeed()/3.0,0
	MoveMouse BT_ScreenWidth/2,MouseY()
	
	; smart cam
	TurnEntity BT_Player,0,BT_PlayerTurnspeed,0
	px=EntityX(BT_PlayerPivot)
	py=BT_Normalize(((MouseY()-(BT_ScreenHeight/2))*1.0/(BT_ScreenHeight/2)),-1,1,0,128)
	pz=EntityZ(BT_PlayerPivot)
	PositionEntity BT_PlayerPivot,px,py,pz
	px=EntityX(BT_PlayerPivot,1)
	py=EntityY(BT_PlayerPivot,1)
	pz=EntityZ(BT_PlayerPivot,1)
	PositionEntity BT_Camera,px,py,pz
	PointEntity BT_Camera,BT_PlayerHead
	
End Function


; -----------------------------------------------------------------------------------------------
; Pick below a given X/Z position to get the exact height there
; -----------------------------------------------------------------------------------------------
Function BT_PickBelow#(entity%,range#=10000,glob=False)
	
	Local height#
	
	Local x#=EntityX(entity%,glob)
	Local y#=EntityY(entity%,glob)
	Local z#=EntityZ(entity%,glob)
	
	;HideEntity BT_PlacesPivot
	
	LinePick(x,y+range,z,0,-range*2,0)
	height=PickedY()
	
	BT_NX#=PickedNX()
	BT_NY#=PickedNY()
	BT_NZ#=PickedNZ()
	
	;ShowEntity BT_PlacesPivot
	
	Return height
	
End Function


; -----------------------------------------------------------------------------------------------
; reads the INI-File to a string
; -----------------------------------------------------------------------------------------------
Function BT_LoadINI$(filename$)
	
	Local linetext$=""
	Local file%=ReadFile(filename)
	If file<>0 Then
		While Not(Eof(file))
			linetext=linetext+ReadLine$(file)+Chr$(0)
		Wend
		CloseFile file
	End If
	
	Return linetext
	
End Function


; -----------------------------------------------------------------------------------------------
; extracts a section key out of a INI-String or sets the given default value
; -----------------------------------------------------------------------------------------------
Function BT_GetINI$(section$,key$,defaultvalue$="",ini$="")
	
 	section="["+Upper$(Trim$(section))+"]"
	key=Upper$(Trim$(key))
	
	;Local ini$=FileToString(filename)
	Local UpperINI$=Upper$(ini)
	Local value$=""
 	Local sectionpos%=Instr(UpperINI,section)
	
	Local keypos%,startpos%,endpos%,nextsection%
	
	If (sectionpos<>0) Then
		
		keypos=Instr(UpperINI,key,(sectionpos+Len(section)+1))
		
		If (keypos<>0) Then
			
			nextsection=Instr(UpperINI,"[",(sectionpos+Len(section)+1))
			
			If nextsection=0 Or (nextsection=>1 And keypos<nextsection)
				
				startpos=Instr(UpperINI,"=",(keypos + 1))
				
				If (startpos<>0) Then
					
					endpos=Instr(UpperINI,Chr$(0),(startpos + 1))
					
					If (endpos<>0) Then
						
						value=Trim$(Mid$(ini,startpos+1,(endpos-startpos-1)))
						
					End If
					
				End If
				
			EndIf
			
		End If
		
	End If
	
	If (value<>"") Then Return value Else Return defaultvalue
	
End Function


; -----------------------------------------------------------------------------------------------
; Color Gradient Source (Percent,R,G,B)
; -----------------------------------------------------------------------------------------------

.BT_Ambientlight
Data   0.0, 16, 32, 48
Data  15.0, 16, 32, 48
Data  25.0,128, 96, 64
Data  35.0,128,128,128
Data  50.0,128,128,128
Data  65.0,128,128,128
Data  75.0,128, 96, 64
Data  85.0, 16, 32, 48
Data 100.0, 16, 32, 48

.BT_Sunsize
Data   0.0,  0,  0,  0
Data  10.0, 32, 32, 32
Data  25.0,192,192,192
Data  35.0, 96, 96, 96
Data  50.0, 96, 96, 96
Data  65.0, 96, 96, 96
Data  75.0,192,192,192
Data  90.0, 32, 32, 32
Data 100.0,  0,  0,  0

.BT_StarLight
Data   0.0,255,255,255
Data  15.0,128,128,128
Data  25.0,  0,  0,  0
Data  50.0,  0,  0,  0
Data  75.0,  0,  0,  0
Data  85.0,128,128,128
Data 100.0,255,255,255

.BT_MoonAlpha
Data   0.0,255,255,255
Data  15.0,255,255,255
Data  20.0,192,192,192
Data  25.0, 32, 32, 32
Data  50.0,  8,  8,  8
Data  75.0, 32, 32, 32
Data  80.0,192,192,192
Data  85.0,255,255,255
Data 100.0,255,255,255

.BT_Brightness
Data   0.0,  0,  0,  0
Data  25.0,255,255,255
Data  35.0,128,128,128
Data  50.0, 64, 64, 64
Data  65.0,128,128,128
Data  75.0,255,255,255
Data 100.0,  0,  0,  0

.BT_ClsColor
Data   0.0,   4, 8, 16
Data  15.0,   4, 8, 16
Data  25.0, 32, 48, 64
Data  35.0,100,150,200
Data  50.0,100,150,200
Data  65.0,100,150,200
Data  75.0, 32, 48, 64
Data  85.0,   4, 8, 16
Data 100.0,   4, 8, 16

.BT_HazeColor
Data   0.0, 12, 24, 48
Data  15.0, 12, 24, 48
Data  25.0, 64, 64, 64
Data  35.0,200,224,255
Data  50.0,200,224,255
Data  65.0,200,224,255
Data  75.0, 64, 64, 64
Data  85.0, 12, 24, 48
Data 100.0, 12, 24, 48

.BT_LightColor
Data   0.0,  0,  0,  0
Data  15.0,  0,  0,  0
Data  25.0,255,192,128
Data  35.0,255,255,192
Data  50.0,255,255,255
Data  65.0,255,255,192
Data  75.0,255,192,128
Data  85.0,  0,  0,  0
Data 100.0,  0,  0,  0

.BT_SunLightColor
Data   0.0,  0,  0,  0
Data  20.0,128,128, 80
Data  25.0,255,255,160
Data  35.0,255,255,192
Data  50.0,255,255,255
Data  65.0,255,255,192
Data  75.0,255,255,160
Data  80.0,128,128, 80
Data 100.0,  0,  0,  0

.BT_OceanColor
Data   0.0,  8, 16, 24
Data  25.0,  0, 32, 96
Data  35.0, 32, 64,192
Data  50.0, 32,128,255
Data  65.0, 32, 64,192
Data  75.0,  0, 32, 96
Data 100.0,  8, 16, 24

.BT_SunAspect
Data   0.0, 64, 64, 64
Data  20.0, 64, 64, 64
Data  25.0,192, 64,192
Data  35.0, 64, 64, 64
Data  50.0, 64, 64, 64
Data  65.0, 64, 64, 64
Data  75.0,192, 64,192
Data  80.0, 64, 64, 64
Data 100.0, 64, 64, 64

.BT_SunLightRange
Data   0.0,  0,  0,  0
Data  10.0, 32, 32, 32
Data  25.0,128,128,128
Data  35.0,160,160,160
Data  50.0,192,192,192
Data  65.0,160,160,160
Data  75.0,128,128,128
Data  90.0, 32, 32, 32
Data 100.0,  0,  0,  0

.BT_MoonLightRange
Data   0.0,255,255,255
Data  10.0,128,128,128
Data  25.0,  0,  0,  0
Data  35.0,  0,  0,  0
Data  50.0,  0,  0,  0
Data  65.0,  0,  0,  0
Data  75.0,  0,  0,  0
Data  90.0,128,128,128
Data 100.0,255,255,255

.BT_Redbar
Data   0.0,224, 23,  0
Data 100.0,114, 21,  0

.BT_Greenbar
Data   0.0, 52,224,  0
Data 100.0, 22,151,  0
;~IDEal Editor Parameters:
;~C#Blitz3D