Graphics3D 800,600,32,2

Include "blitzsky.bb"

Const scene$="middleearth"

Const RANGE#            = 8192

BS_SunAngle#			= 180.0
BS_MoonAngle#			= 180.0

BS_ShowGround%			= 1
BS_ShowOcean%			= 1

Global FreeLookXS#,FreeLookZS#,FreeLookRotXS#,FreeLookRotYS#

BS_Camera=CreatePivot()
cam=CreateCamera()
BS_InitBlitzSky(cam)
EntityParent cam,BS_Camera

CameraRange cam,0.05,RANGE
CameraFogRange cam,RANGE/2.0,RANGE
CameraFogMode cam,True
CameraFogColor cam,150,200,255;r,g,b
CameraClsColor cam,150,200,255;r,g,b
EntityType cam,1
EntityRadius cam,3
PositionEntity cam,0,64,0

mesh=LoadMesh("b3d/"+scene+"/terrain.b3d")

While Not KeyHit(1)
	
	If KeyHit(57) Then wf=1-wf : WireFrame wf
	
	FreeLook(cam,0.1)
	
	; get current Camera position
	x#=EntityX(cam,1)
	y#=EntityY(cam,1)
	z#=EntityZ(cam,1)
	
	; attach light and sky pivots to camera position (not vertical)
	PositionEntity BS_SunPivot,x,y,z
	PositionEntity BS_MoonPivot,x,y,z
	PositionEntity BS_Skypivot,x,y,z
	
	; Update BlitzSky System
	BS_UpdateBlitzSky(cam)
	
	RenderWorld	
	
	AppTitle "Tris: "+TrisRendered()+" X: "+Int(x)+" Y: "+Int(y)+" Z: "+Int(z)

	Flip 0
	
Wend

End

Function FreeLook(camera,movespeed#=1.0,smoothness#=0.8,rotspeed#=0.9,maxpitch#=85.0)
	
	Local p#,pitch#,SpeedMultiplicator#=1.0
	
	; LMB/RMB: speed increase
	If MouseDown(1) Then SpeedMultiplicator=5
	If MouseDown(2) Then SpeedMultiplicator=10
	
	If movespeed>0 Then
		FreeLookXS=(FreeLookXS+((KeyDown(205))-(KeyDown(203)))*movespeed)*smoothness
		FreeLookZS=(FreeLookZS+((KeyDown(200))-(KeyDown(208)))*movespeed)*smoothness
		MoveEntity camera,FreeLookXS*SpeedMultiplicator,0,FreeLookZS*SpeedMultiplicator
	EndIf
	
	FreeLookRotXS=((MouseXSpeed()-FreeLookRotXS)*0.2+FreeLookRotXS)*rotspeed
	FreeLookRotYS=((MouseYSpeed()-FreeLookRotYS)*0.2+FreeLookRotYS)*rotspeed
	
	p=EntityPitch(camera)+FreeLookRotYS
	If p<-maxpitch Then pitch=-maxpitch ElseIf p>maxpitch Then pitch=maxpitch Else pitch=p
	RotateEntity camera,pitch,-FreeLookRotXS+EntityYaw(camera),0
	
	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
	
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D